////////////////////////////////////////////////////////////////////////////
//  Mech Warrior
//
//  Basic Move
//  Basic Attack

////////////////////////////////////////////////////////////////////////////
//  Move Phase
//
//  Forward Left Right (Done) (Info)
//

////////////////////////////////////////////////////////////////////////////
//  Attack Phase
//
//  Fire All (Done) (Info)
//

//  Initialize
//  Main Loop
//  Exit Loop
//

//typedef unsigned char byte;
//typedef unsigned int  word;

char *State[] = {"Off",
                 "On",
                 0x0000};

char *YesNo[] = {"No",
                 "Yes",
                 0x0000};

char *LocationName[] = {
                        "Critical Hit",
                        "Head",
			"Centre Torso",
			"Right Torso",
			"Left Torso",
			"Right Arm",
			"Left Arm",
			"Right Leg",
			"Left Leg",
			"Rear Centre Torso",
			"Rear Right Torso",
			"Rear Left Torso",
			"Right Arm",
			"Left Arm",
			"Right Leg",
			"Left Leg",
                        "Head",
			0x0000
			};

char *LocName[]       = {"HD","CT","RT","LT","RA","LA","RL","LL","RCT","RRT","RLT","RA","LA","RL","LL","RHD",0x0000};

char *TankLocationName[] = {"Front",
			    "Right",
			    "Left",
			    "Rear",
			    "Turret",
			    "Rear Turret",
			    "Right Aft",
			    "Left Aft",
			    "Gradius",
			    "Body",
			    0x0000
			    };

char *TankLocName[]      = {"FR","RG","LF","BK","TR","2T","RR","LR","GR","BD",0x0000};

char *TankTypes[]        = {"Tracked Vehicle",
                            "Wheeled Vehicle",
                            "Hovercraft",
                            "VTOL",
                            "Surface Naval Craft",
                            "Submarine",
                            "Hydrofoil",
                            0x0000};

// Key Stroke Definitions
#define         CTRLA           129//
#define         CTRLC           131//Break
#define         CTRLD           132//
#define         CTRLG           135//Fix Later
#define         CTRLH           136//
#define         CTRLO           143//
#define         CTRLS           147//
#define         CTRLW           151//
#define         CTRLE           133//

#define         FIRE            32
#define         DONE            13
#define         QUIT            27
#define         SPACE           32
#define         ENTER           13
#define         ESC             27
#define         TAB              9
#define         SHIFTTAB        15
#define         RETURNNULL     127
#define         Home           199
#define         End            207
#define         PgUp           201
#define         PgDn           209
#define         INS            210
#define         DEL            211
#define         Up             200
#define         Down           208
#define         Left           203
#define         Right          205

#define         HIGH             1
#define         LOW              2
#define         LEFT             3
#define         RIGHT            4
#define         AIM              5
#define         TARGETED         6

#define         Off             0
#define         On              1

#define         True            0
#define         False           1

#define         PRONE           0
#define         STANDING        1


#define         MAXUNITS         32
#define         MAXMECHS         32
#define         MAXVEHICLE       32
#define         MAXINFANTRY      32
#define         MAXELEMENTAL     32

#define         MAXITEMS         32

#define         MapXMax          80
#define         MapXMin          00
#define         MAXLENGTH       256

#define         MECH              1
#define         VEHICLE           2
#define         INFANTRY          3
#define         ELEMENTAL         4
#define         FORTRESS          5
#define         RUBBLE           10

#define         NORMALMECH        0
#define         QUADMECH          1
#define         LANDAIRMECH       2
#define         OMNIMECH          3
#define         QUADLAM           4
#define         QUADOMNI          5

#define         TRACKED           0
#define         WHEELED           1
#define         HOVER             2
#define         VTOL              3

#ifndef    PI// PI is not always defined in MATH.H
  #define    PI      3.14159
#endif

// random() is better than rand() but it is not in every distro
#if defined(random)
  #define                 rolld6          (random() %6) + 1
  #define                 roll2d6         rolld6 + rolld6
  #define                 rolld12         (random() %12) + 1
  #define                 rolldx(a)       ((random() %a)+1)
#else
  #define                 rolld6          (rand() %6) + 1
  #define                 roll2d6         rolld6 + rolld6
  #define                 rolld12         (rand() %12) + 1
  #define                 rolldx(a)       ((rand() %a)+1)
#endif

  #define                 GunneryRoll     (Options.LinearGunnery ==On)?rolld12:roll2d6
  #define                 PilotingRoll    (Options.LinearPiloting==On)?rolld12:roll2d6

int rollxd6(int x) {int i,r=0;for(i=0;i<x;i++)r+=rolld6;return r;}

char *Functional[] = {"Non-Functional",
		      "Functional",
		      0x0000
		      };

//WeaponTable WeaponTable[20];
int	    NumberOfWeapons;
char        LOSstring[MAXLENGTH];
MapData     Map;
OldMapData  hexmap;

Vector vec[12];
int angacc = 30;

int  ItemLimit,Items = 0;
Item Item[MAXITEMS];

Unit *uptr,ai,*unit[MAXUNITS],*Target;
int  Units;
Mech      Mech     [MAXMECHS];
Vehicle   Vehicle  [MAXVEHICLE];
Infantry  Infantry [MAXINFANTRY];
Elemental Elemental[MAXELEMENTAL];
int  Mechs;
Unit FakeUnit; // A fake unit to help targeting
int  CurrentUnit;
int  WindDirection = 1;

FONT *SmallFont;

int globalx, globaly;
int scrollx, scrolly;
int textbarx,textbary;
int centextx,centexty;

int MapMax = 16;
int Maps;
int Xmin=0,Xmax=68;
int Ymin=0,Ymax=32;
int MapWidth=34-2,MapHeight=16;
int SpriteWidth=32,SpriteHeight=20;
char ScrollLock = Off;

char MPC[255]; // Movement Point Cost
char MPH[255]; // Movement Point Height
char SmokeMask[255]; // Smoke Mask for LOS
char TerHeight[255]; // Height of Terrain
char TerNameIndex[255];// Index of Terrain Names

char LastString[80];
int  LastColour;

int MoveRest  ; // AI Speeds
int MoveTime  ;
int ReactTime ;
int WeaponTime;
int PhysTime  ;

int PlayerTime; // Time to slow on Automated player functions

char TypeCon[6]     = {0,1,2,3,4,5};
char conHead[12]    = {-1, 0,-2, 1,-3, 2,-4, 3,-5, 4,-6, 5};

//Hit Tables
enum {FrontHit,LeftHit,RightHit,BackHit,FrontPunch,LeftPunch,RightPunch,BackPunch,FrontKick,LeftKick,RightKick,BackKick,FrontQuad,LeftQuad,RightQuad,BackQuad};

char *MovType [4][7] = {{"Stand","Walk","Run","Sprint","Evade","Jump",0x0000},           //Mechs
			{"All Stop","Cruise","Flank","Over Flank","Evade","Jump",0x0000},   //Vehicles
			{"Stall","Thrust","OverThrust","OverJump","Evade","Jump",0x0000},//Jets
			0x0000};
char *MoveCode[4][6] = {{"[S]tand","[W]alk","[R]un","[S]print","[J]ump",0x0000},            //Mechs
			{"[A]ll Stop","[C]ruise","[F]lank","[O]ver Flank","[J]ump",0x0000},    //Vehicles
			{"[S]tall","[T]hrust","[O]verThrust","[O]ver Jump","[J]ump",0x0000},//Jets
			0x0000};


char *PhysCode[4][6] = {{"[P]unch","[K]ick","p[U]sh","[C]harge","[D]OA",0x0000},            //Mechs
			{"[A]ll Stop","[C]ruise","[F]lank","[O]ver Flank","[J]ump",0x0000},    //Vehicles
			{"[S]tall","[T]hrust","[O]verThrust","[O]ver Jump","[J]ump",0x0000},//Jets
			0x0000};

char *Positions[]   = { "Prone",
                        "Standing",
                        0x0000 };

////////////////////////////////////////////////////////////////////////////
// Game Tables
//
//

////////////////////////////////////////////////////////////////////////////
// Missile / Hit Tables
//
//
//                  HD  CT  RT  LT  RA  LA   RL  LL CTr RTr LTr
int RightArc[13]= { 65, 65, 65, 65,125, 65 , 65, 65,-65,-65,-65,0x0000};
int LeftArc [13]= {-65,-65,-65,-65,-65,-125,-65,-65, 65, 65, 65,0x0000};
//  The Angles covered by each weapon in a location
//                    FR  LS   RS  BK   TR
int RightTank [ 6]= { 65, -65,125,-115, 32,0x0000};
int LeftTank  [ 6]= {-65,-125, 65, 115,-32,0x0000};

//                    60120180240300360
int HeadCon[7]    = {  0, 1, 3, 3, 2, 0, 0x0000}; // Convert Angle to facing

int HitLoc[5][15] = {{ 0, 0,-1,RA,RA,RL,RT,CT,LT,LL,LA,LA,HD,0x0000},
		     { 0, 0,-1,LL,LA,LA,LL,LT,CT,RT,RA,RL,HD,0x0000},
		     { 0, 0,-1,RL,RA,RA,RL,RT,CT,LT,LA,LL,HD,0x0000},
		     { 0, 0,-1,RAr,RAr,RLr,RTr,CTr,LTr,LLr,LAr,LAr,HDr,0x0000},
		     {CT,CT,CT,RA,RA,RL,RT,CT,LT,LL,LA,LA,HD,0x0000}};
//                     0, 1, 2, 3, 4, 5, 6

int PunchLoc[5][8]= {{ 0,LA,LT,CT,RT,RA,HD,0x0000},
		     { 0,LT,LT,CT,LA,LA,HD,0x0000},
		     { 0,RT,RT,CT,RA,RA,HD,0x0000},
		     { 0,LAr,LTr,CTr,RTr,RAr,HDr,0x0000},
		     { 0,LA,LT,CT,RT,RA,HD,0x0000}};

int UpperLoc[6][15]={{ 0, 0,-1,RA,RA,-2,RT,CT,LT,-2,LA,LA,HD,0x0000}, // Like Punch, only damage to chest and arms applied
		     { 0, 0,-1,-2,LA,LA,-2,LT,CT,RT,RA,-2,HD,0x0000},
		     { 0, 0,-1,-2,RA,RA,-2,RT,CT,LT,LA,-2,HD,0x0000}, // Damage to legs is wasted
		     { 0, 0,-1,RAr,RAr,-2,RTr,CTr,LTr,-2,LAr,LAr,HDr,0x0000},
		     {CT,CT,CT,RA,RA,RL,RT,CT,LT,LL,LA,LA,HD,0x0000},
		     {0x0000}};


int KickLoc[6][8] = {{ 0,LL,LL,LL,RL,RL,RL,0x0000},
		     { 0,LL,LL,LL,LL,RL,RL,0x0000},
		     { 0,RL,RL,RL,RL,LL,LL,0x0000},
		     { 0,LLr,LLr,LLr,RLr,RLr,RLr,0x0000},
		     { 0,LL,LL,LL,RL,RL,RL,0x0000},
                     {0x0000}};

int QuadLoc[5][15]= {{ 0, 0,-1,RL,RA,RA,RT,CT,LT,LA,LA,LL,HD,0x0000},
		     { 0, 0,-1,LL,LA,LA,LL,LT,CT,RT,RA,RL,HD,0x0000},
		     { 0, 0,-1,RL,RA,RA,RL,RT,CT,LT,LA,LL,HD,0x0000},
		     { 0, 0,-1,RLr,RAr,RAr,RTr,CTr,LTr,LAr,LAr,LLr,HDr,0x0000},
		     {CT,CT,CT,RA,RA,RL,RT,CT,LT,LL,LA,LA,HD,0x0000}};

// Infantry Swarm Location
int SwarmLoc      [] = {-2,-2,HD,CTr,RTr,RA,CT,LA,LT,LTr,CTr,HD};

// Tank Damage Locations
int TankLoc[5][15]= {{ 0, 0, 1, 2, 3, 4, 0, 0, 0, 0, 5, 6, 7,0x0000},
                     { 0, 0, 1, 2, 3, 3, 0, 0, 0, 4, 5, 6, 7,0x0000},
                     { 0, 0, 1, 2, 3, 3, 0, 0, 0, 4, 5, 6, 7,0x0000},
                     { 0, 0, 1, 2, 3, 4, 0, 0, 0, 0, 5, 6, 7,0x0000},
                     { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0x0000}};
                     
//                         0  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15
//                        HD CT RT LT RA LA RL LLrCTrRTrLTrRArLArRLrLLrHD
int TransferDamage[16] = {-2,-2, 1, 1, 2, 3, 2, 3,-2, 8, 8, 9,10, 9,10, 0};

//	         0  1  2  3  4  5  6  7  8  9 10 11 12  Die Roll
// SRM Tables
char Mis2[14] = {0, 0, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 0x0000};
char Mis4[14] = {0, 0, 1, 2, 2, 2, 2, 3, 3, 3, 3, 4, 4, 0x0000};
char Mis6[14] = {0, 0, 2, 2, 3, 3, 4, 4, 4, 5, 5, 6, 6, 0x0000};

// LRM Tables
char Mis5 [14]= {0, 0, 1, 2, 2, 3, 3, 3, 3, 4, 4, 5, 5, 0x0000};
char Mis10[14]= {0, 0, 3, 3, 4, 6, 6, 6, 6, 8, 8,10,10, 0x0000};
char Mis15[14]= {0, 0, 5, 5, 6, 9, 9, 9, 9,12,12,15,15, 0x0000};
char Mis20[14]= {0, 0, 6, 6, 9,12,12,12,12,16,16,20,20, 0x0000};

// Miscellaneous
char Mis0 [14]= {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0x0000};
char Mis1 [14]= {0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0x0000};

char Mis3 [14]= {0, 0, 1, 1, 1, 2, 2, 2, 2, 2, 3, 3, 3, 0x0000};
char Mis9 [14]= {0, 0, 3, 3, 4, 5, 5, 5, 5, 7, 7, 9, 9, 0x0000};
char Mis12[14]= {0, 0, 4, 4, 5, 8, 8, 8, 8,10,10,12,12, 0x0000};

char Mis7 [14]= {0, 0, 3, 3, 4, 4, 5, 5, 5, 5, 7, 7, 7, 0x0000};
char Mis8 [14]= {0, 0, 3, 3, 4, 5, 5, 5, 5, 7, 7, 8, 8, 0x0000};

char *Misptr[22] = {Mis0,Mis1,Mis2,Mis3,Mis4,
		    Mis5,Mis6,Mis7,Mis8,Mis9,
		    Mis10,Mis10,Mis12,Mis12,Mis15,
		    Mis15,Mis15,Mis15,Mis20,Mis20,
		    Mis20,0x0000};

// Movement Datum

// Target Evasion
//                     0                             1                             2                             3
// Hexes Moved          0  1  2  3  4  5  6  7  8  9  0  1  2  3  4  5  6  7  8  9  0  1  2  3  4  5  6  7  8  9  0
char TargetEvasion[32]={0, 0, 0, 1, 1, 2, 2, 3, 3, 3, 4, 4, 4, 4, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6, 6, 7, 7, 7, 7, 7, 7, 0x0000};

// Weapon Datum

// Heat Datum
//                     0                             1                             2                             3
//                      0  1  2  3  4  5  6  7  8  9  0  1  2  3  4  5  6  7  8  9  0  1  2  3  4  5  6  7  8  9  0
char HeatSlow[32] =   { 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5, 6, 0x0000};
// Slow down from Heat
char HeatAcc [32] =   { 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 5, 0x0000};
// Targeting Interference from heat
char HeatShut[32] =   { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 4, 4, 4, 6, 6, 6, 6, 8, 8, 8, 8,10,10,10,10,13, 0x0000};
// Chance of Shut down from heat (Automatic Shut Down at 30)
char HeatAmmo[32] =   { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 4, 4, 4, 6, 6, 6, 6, 6, 8, 8, 8, 0x0000};
// Chance of Ammo Explosion from Heat
char HeatInf [32] =   { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 4, 4, 4, 6, 6, 6, 6, 6, 6, 8, 8, 8, 8,10,10,10,10,10,12,12, 0x0000};
// Chance of Inferno Ammo Explosion from Heat

enum {NOMELEE=-1,CLUB=0,HATCHET=1,SWORD=2,MACE=3,CLAW=4};
/*
#define         NOMELEE         -1
#define         CLUB             0
#define         HATCHET          1
#define         SWORD            2
#define         MACE             3
#define         CLAW             4
*/
char *MeleeWeapon [] = {
                        "Club",
                        "Hatchet",
                        "Sword",
                        "Mace",
                        "Claw",
                        0x0000};

int CritcalHits[13] = {0,0,0,0,0,0,0,1,1,2,2,3}; // Critical Hits
/*
char *WCritName[]   =  {"-------","Flamer ","L.Laser","M.Laser","S.Laser","PPC    ","AC/2   ","AC/5   ","AC/10  ","AC/20  ","Mac.Gun","LRM-5  ","LRM-10 ","LRM-15 ","LRM-20 ","SRM 2  ","SRM 4  ","SRM 6  ",0x0000};
char *MCritName[]   =  {"-------","-------","-------","-------","-------","-------","@ AC/2 ","@ AC/5 ","@ AC/10","@ AC/20","@ MG   ","@ LRM-5","@ LRM10","@ LRM15","@ LRM20","@ SRM 2","@ SRM 4","@ SRM 6",0x0000};
char *ECritName[]   =  {"HS     ","JumpJet",0x0000};
char *ACritName[]   =  {"Shouldr","Up.Arm ","Lwr.Arm","Hand   ","Hip    ","Up.Leg ","Lwr.Leg","Foot   ","Engine ","Gyro   ","L.Suprt","Sensors","CockPit",0x0000};
*/
enum {NULLCLASS,WEAPON,AMMO,EQUIPMENT,ACTUATOR};

char CritName[5][20][8]={{"N------","Fer.Fib","E.Steel","TripStr",0x0000},
                         {"Flamer ","L.Laser","M.Laser","S.Laser","PPC    ","AC/2   ","AC/5   ","AC/10  ","AC/20  ","Mac.Gun","LRM-5  ","LRM-10 ","LRM-15 ","LRM-20 ","SRM 2  ","SRM 4  ","SRM 6  ",0x0000},
                         {"-------","-------","-------","-------","-------","@ AC/2 ","@ AC/5 ","@ AC/10","@ AC/20","@ MG   ","@ LRM-5","@ LRM10","@ LRM15","@ LRM20","@ SRM 2","@ SRM 4","@ SRM 6",0x0000},
                         {"HS     ","JumpJet","CASE   ","ART IV ","HATCHET","TRGCOMP","ECM    ","APROBE ","A-POD  ","MASC   ",0x0000},
                         {"Shouldr","Up.Arm ","Lwr.Arm","Hand   ","Hip    ","Up.Leg ","Lwr.Leg","Foot   ","Engine ","Gyro   ","L.Suprt","CockPit","Sensors","Engine ",0x0000}};

typedef struct EGAcomp { // Define EGA Colour defaults in 24 bit
byte r;
byte g;
byte b;
};

EGAcomp EGA[] = {{  0,  0,  0}, // 0  Black
           {  0,  0,171}, // 1  Blue
           {  0,171,  0}, // 2  Green
           {  0,171,171}, // 3  Cyan
           {171,  0,  0}, // 4  Red
           {171,  0,171}, // 5  Magenta
           {171, 83,  0}, // 6  Brown
           {171,171,171}, // 7  Grey
           { 83, 83, 83}, // 8  Dark Grey
           { 83, 83,255}, // 9  Light Blue
           { 83,255, 83}, // 10 Light Green
           { 83,255,255}, // 11 Light Cyan
           {255, 83, 83}, // 12 Light Red (Pink)
           {255, 83,255}, // 13 Light Magenta
           {255,255, 83}, // 14 Yellow
           {255,255,255}, // 15 White
           {  0,  0,  0}};// Null

int EGAColour[] = {         0, //  0 Black
                          171, //  1 Blue
                        43776, //  2 Green
                        43947, //  3 Cyan
                     11206656, //  4 Red
                     11206827, //  5 Magenta
                     11227904, //  6 Brown
                     11250603, //  7 Grey
                      5460819, //  8 Dark Grey
                      5460991, //  9 Light Blue
                      5504851, // 10 Light Green
                      5505023, // 11 Light Cyan
                     16733011, // 12 Light Red (Pink)
                     16733183, // 13 Light Magenta
                     16777043, // 14 Yellow
                     16777215, // 15 White
                     0x0000};

char *TerrainName[] = {"Plains",
                       "Light Forest",
                       "Heavy Forest",
                       "UltraHeavy Forest",
                       "Light Jungle",
                       "Heavy Jungle",
                       "UltraHeavy Jungle",
                       "Rough",
                       "Paved",
                       "Water",
                       "Rubble",
                       "Light Building",
                       "Medium Building",
                       "Heavy Building",
                       "Reinforced Building",
                       0x0000};

// Options
int  UnitType  [MAXUNITS];
char MapName   [16][40];
char MaskName  [16][40];
char MechName  [MAXUNITS][30];
char SpriteName[MAXUNITS][30];
char PilotName [MAXUNITS][30];
char AIName    [MAXUNITS][40];
int  Array     [MAXUNITS][12];

// Converts Allegro keyboard Scan Codes into standard codes + 128
byte ScanCodes[] = {/*0   1   2   3   4   5   6   7   8   9  
/*0-9*/               0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*10-19*/             0,  0,  0,  0,  0,  0,  0,  0,  0,  0,    
/*20-29*/             0,  0,  0,  0,  0,  0,  0,  0,  0,  0,    
/*30-39*/             0,  0,  0,  0,  0,  0,  0,  0,  0, 80,
/*40-49*/             0, 75,  0, 77,  0, 72,  0,  0,  0,  0,
/*50-59*/             0,  0,  0,  0,  0,  0,  0,  0,  0,  0,    
/*60-69*/             0,  0,  0,  0,  0,  0,  0,  0,  0,  0,    
/*70-79*/             0,  0,  0,  0,  0,  0,  0,  0,  0,  0,    
/*80-89*/             0,  0, 75, 77, 72, 80,  0,  0,  0,  0,    
/*90-99*/             0,  0,  0,  0,  0,  0,  0,  0,  0,  0,    
/*100-109*/           0,  0,  0,  0,  0,  0,  0,  0,  0,  0,    0x0000};


#define         lcase            32
#define         ucase           -32

//#define         TRUE             't'
//#define         FALSE            'f'
#define         MAXOPTIONS       57
                       
