/////////////////////////////////////////////////////////////////////////////
// .DBM Load
// Similar to .HMP Load, certain File I/O functions are kept there
//




MechCriticals ConvertDBMCritType( int Type , int RearMod );
int ConvertDBMWeap( int Type );
int ConvertDBMLoc ( int Loc  );

int readDBMCrits(class Mech &Mech, int Loc, int Slots, FILE *file);
//int readCrits(int Loc, int Slot, FILE *file);


#define         lcase            32
#define         ucase           -32

int strcomp(char *String, char *Comp);

enum {dNULLS,dWEAPON,dAMMO,dEQUIPMENT,dACTUATOR,dUNKNOWN,dWEAPONCONT};


// Main
int LoadDBM(class Mech &Mech, char *Name) {
int i,j,k,l,m,n;
byte  ch;
char  String[160];
FILE *DBM;
/*
   if (argc != 2) {
      printf("Usage: MechName\n");
      return 1;
   }
*/
//DBM = fopen("vtr-9a~1.DBM","rb");
sprintf(String,"%s.DBM",Name);
DBM = fopen(String,"rb");

if (DBM == NULL) return LoadMEP(Mech,Name);

// Quit if no file found

// Variables in read order
int  DBMver; // DBM ver 1 / 2 etc
int  Type, Tonnage;
//char Name [30];
//char Model[30];
int  Year;
int  Level;
long Cost;
int  BF2Length;
int  TechBase;
int  Legs; // Biped / Quad / LAM / Armless
int  ISType; // Standard / EndoSteel / Composite / Reinforced / Utility
int  EngineRating;
int  EngineType; // Fusion / XL / XXL / Compact / ICE
int  Walk;
int  Run;
int  Sprint;
int  Jump;
int  intHS;
int  HS;
int  HSType; // Standard / Double / Compact / Laser
int  ArmourType; // Standard / FerroFibre / Stealth / Reactive / Reflective
		 // Heavy FF / Light FF / Patchwork

int  Armour[12]; // Armour on Mech
int  MType;      // Myomer Type - Standard / Triple Strength / Masc
int  NumWeap;    // Number of Weapons

int  NumCrits;   // Number of Critical Slot - should be 76+1 for Normal Mechs
int  CritDex;    // Critical Index

// get Header (5 char)
readStringLen(String,DBM,0x19);

DBMver = readInt (DBM); // ?

if (DBMver != 1) {
//  clrscr();
  printf("Incorrect DBM version\n");
  printf("Currently only DBM version 1.xx supported\n");
  printf("%d \n",DBMver);
  return 3;
  }

i = readInt (DBM); // Name Len
readStringLen(Mech.Name ,DBM,i);
i = readInt (DBM); // Code Len
readStringLen(Mech.Code,DBM,i);
//printf("%s : %s \n",Mech.Name,Mech.Code);

readInt (DBM);
readInt (DBM);
Mech.Tons    = readInt (DBM);

readStringLen(String,DBM,0x10); // Unknown

Mech.Walk    = readInt (DBM);
Run          = readInt (DBM);
Sprint       = readInt (DBM);
Mech.Jump    = readInt (DBM);

//printf("Tons %d : Walk %d  Run %d  Sprint %d  Jump %d\n",Mech.Tons,Mech.Walk,Run,Sprint,Mech.Jump);

readStringLen(String,DBM,0x26);  // Unknown

intHS          = readInt (DBM);
Mech.HeatSinks = readInt (DBM);

//printf("Internal Heat Sinks %d   Total Heat Sinks %d\n",intHS,Mech.HeatSinks);

readStringLen(String,DBM,0x0A); // Unknown
i = readInt (DBM); // Unknown
readStringLen(String,DBM,0xB4); // Unknown
readStringLen(String,DBM,0x10); // Breaker

Mech.Weapons = readInt (DBM); // Number of Weapons and pieces of Equipment
Mech.Weapons ++;

//printf("Number of Weapons : %d \n",Mech.NumWeap);

k = 0;
for (i=0;i<Mech.Weapons;i++) {
  j                   = ConvertDBMWeap( readInt(DBM) );
  readStringLen(String,DBM,0x0C); // Equipment Reader
  m                   = ConvertDBMLoc ( readInt(DBM) );
  readStringLen(String,DBM,0x0C); // Equipment Reader
  if (j != -1) {
    Mech.Weapon[k] = WeaponTable[j];
    Mech.Weapon[k].Loc   = m;
    Mech.Weapon[k].State = 1;
    k ++;
    }
  }

  Mech.Weapons = k;
  
  Mech.Armour[LA]  = readInt (DBM);
  Mech.Armour[LT]  = readInt (DBM);
  Mech.Armour[LL]  = readInt (DBM);
  Mech.Armour[RL]  = readInt (DBM);
  Mech.Armour[RT]  = readInt (DBM);
  Mech.Armour[RA]  = readInt (DBM);
  Mech.Armour[CT]  = readInt (DBM);
  Mech.Armour[HD]  = readInt (DBM);
  Mech.Armour[LTr] = readInt (DBM);
  Mech.Armour[RTr] = readInt (DBM);
  Mech.Armour[CTr] = readInt (DBM);

/*
printf("Armour Table :\n");
printf("        %2d\n",Mech.Armour[HD]);
printf("%2d  %2d  %2d",Mech.Armour[LA],Mech.Armour[LT],Mech.Armour[CT]);
printf("  %2d  %2d\n",Mech.Armour[RT],Mech.Armour[RA]);
printf("    %2d     %2d\n",Mech.Armour[LL],Mech.Armour[RL]);
*/
NumCrits = readInt(DBM); // Number of Criticals for a mech, usually 76+1

// Read Crits from File

  readDBMCrits(Mech,LA,12,DBM);
  readDBMCrits(Mech,LT,12,DBM);
  readDBMCrits(Mech,LL,6,DBM);
  readDBMCrits(Mech,RL,6,DBM);
  readDBMCrits(Mech,RT,12,DBM);
  readDBMCrits(Mech,RA,12,DBM);
  readDBMCrits(Mech,CT,12,DBM);
  readDBMCrits(Mech,HD,6,DBM);

//for (i=0;i<0x10;i++)
//  printf("%d\n",String[i]);

fclose(DBM);
//for (i=0;i<8;i++)
//  printf("%d\n",Mech.CritSlot[i]);

  if (Mech.Crit[4][3].Class == 4 && Mech.Crit[5][3].Type == 3)
    Mech.RightArm.Length = 4;
    else
    if (Mech.Crit[4][2].Class == 4 && Mech.Crit[5][2].Type == 2)
      Mech.RightArm.Length = 3;
    else
      Mech.RightArm.Length = 2;

//if (Mech.Crit[5][3].Class == 4 && Mech.Crit[5][3].Type == 14) // Hatchet
  if (Mech.Crit[5][3].Class == 4 && Mech.Crit[5][3].Type == 3)
    Mech.LeftArm.Length = 4;
    else
    if (Mech.Crit[5][2].Class == 4 && Mech.Crit[5][2].Type == 2)
      Mech.LeftArm.Length = 3;
    else
      Mech.LeftArm.Length = 2;

  if (Mech.RightHatchetType == 1)
    Mech.RightArm.Length = 5;
  if (Mech.LeftHatchetType  == 1)
    Mech.LeftArm.Length = 5;

  Mech.Struct[0] = 3;
  Mech.Struct[1] = str[Mech.Tons/5][1];
  Mech.Struct[2] = str[Mech.Tons/5][2];
  Mech.Struct[3] = str[Mech.Tons/5][2];
  Mech.Struct[4] = str[Mech.Tons/5][3];
  Mech.Struct[5] = str[Mech.Tons/5][3];
  Mech.Struct[6] = str[Mech.Tons/5][4];
  Mech.Struct[7] = str[Mech.Tons/5][4];

  Mech.Run      = (Mech.Walk * 3 + 1) / 2;
  Mech.Position = 1; // Mech starts Standing, height equals 1+1 level
  Mech.Heat     = 0; // Mechs Start with no Heat
  Mech.Holding  =-1; // Mechs Start out not Holding Anything
  Mech.Carrying =-1; // Mechs Start out not Carrying any one
  Mech.Size     = 2; // Mech Height

  Mech.Status   = 1;
  Mech.Stacked  = Off;
  Mech.MASCNumber=3;

  Mech.EngineHits      = 0;
  Mech.GyroHits        = 0;
  Mech.SensorHits      = 0;
  Mech.LifeSupportHits = 0;

  Mech.RightArm.Shoulder = On;
  Mech.RightArm.UpperArm = On;
  if (Mech.RightArm.Length >= 3) Mech.RightArm.LowerArm = On;
  if (Mech.RightArm.Length == 4) Mech.RightArm.Hand     = On;
  Mech.LeftArm.Shoulder  = On;
  Mech.LeftArm.UpperArm  = On;
  if (Mech.LeftArm.Length >= 3) Mech.LeftArm.LowerArm  = On;
  if (Mech.LeftArm.Length == 4) Mech.LeftArm.Hand      = On;
  Mech.RightLeg.Hip      = On;
  Mech.RightLeg.UpperLeg = On;
  Mech.RightLeg.LowerLeg = On;
  Mech.RightLeg.Foot     = On;
  Mech.LeftLeg.Hip       = On;
  Mech.LeftLeg.UpperLeg  = On;
  Mech.LeftLeg.LowerLeg  = On;
  Mech.LeftLeg.Foot      = On;

//SaveMech();

return 0;
}

MechCriticals ConvertDBMCritType( int Type , char RearMod ) {
MechCriticals a;
//printf("%ld\n",Type);
//if (RearMod == 255) RearMod = -1;
//RearMod = 0;

        a.Class = dNULLS;
        a.Type  = -1;
        a.Size  = 1;
        a.State = 0;

	if( Type == -1 ) {a.Type = 0; return a;} // Null Set

/* DBM uses different Settings

	if( Type == 0x01 ) a.Type = 0;
	if( Type == 0x02 ) a.Type = 1;
	if( Type == 0x03 ) a.Type = 2;
	if( Type == 0x04 ) a.Type = 3;
	
	if( Type == 0x05 ) a.Type = 4;
	if( Type == 0x06 ) a.Type = 5;
	if( Type == 0x07 ) a.Type = 6;
	if( Type == 0x08 ) a.Type = 7;

	if( Type == 0x0C ) a.Type =10;
	if( Type == 0x0D ) a.Type =12;
	if( Type == 0x0E ) a.Type =11;

*/
        a.Class  = dACTUATOR;
        a.Size   = 1;
        a.State  = 1;

	if( Type == 0x03F3 ) a.Type = 8;
	if( Type == 0x03F4 ) a.Type = 9;

        if (a.Type != -1) return a; // Actuator Set

        a.Class  = dEQUIPMENT;
        a.State  = 1;
	if( Type == 0x03EC ) a.Type = 0, a.Size = 1; // Heat Sink
//	if( Type ==        ) a.Type = 0, a.Size = 3; // Can Only Handle StarLeague
	if( Type == 0x03F5 ) a.Type = 1, a.Size = 1; // Jump Jet

        if (a.Type != -1) return a; // Equipment Set

        a.Class = dWEAPON;
	a.State = RearMod;
	if( Type == 0x14 ) a.Type = 0, a.Size = 1;
	if( Type == 0x15 ) a.Type = 1, a.Size = 2;
	if( Type == 0x16 ) a.Type = 2, a.Size = 1;
	if( Type == 0x18 ) a.Type = 3, a.Size = 1;
	if( Type == 0x17 ) a.Type = 4, a.Size = 3;

	if( Type == 0x1A ) a.Type = 5, a.Size = 1;
	if( Type == 0x1C ) a.Type = 6, a.Size = 4;
	if( Type == 0x19 ) a.Type = 7, a.Size = 7;
	if( Type == 0x1B ) a.Type = 8, a.Size =10;
	if( Type == 0x1D ) a.Type = 9, a.Size = 1;

	if( Type == 0x24 ) a.Type =10, a.Size = 1;
	if( Type == 0x1E ) a.Type =11, a.Size = 2;
	if( Type == 0x20 ) a.Type =12, a.Size = 3;
	if( Type == 0x22 ) a.Type =13, a.Size = 5;

	if( Type == 0x26 ) a.Type =14, a.Size = 1;
	if( Type == 0x28 ) a.Type =15, a.Size = 1;
	if( Type == 0x2A ) a.Type =16, a.Size = 2;

        if (a.Type != -1) return a; // Weapon Set

//	Type &= 0xFFFF;

        a.Class = dAMMO;
        a.Size  = 1;

	if( Type == 0x002E ) a.Type = 0, a.State =  45;
	if( Type == 0x0030 ) a.Type = 1, a.State =  20;
	if( Type == 0x002D ) a.Type = 2, a.State =  10;
	if( Type == 0x002F ) a.Type = 3, a.State =   5;
	if( Type == 0x0035 ) a.Type = 4, a.State = 200;
	if( Type == 0x0036 ) a.Type = 4, a.State = 100;

	if( Type == 0x0034 ) a.Type = 5, a.State =  24;
	if( Type == 0x0031 ) a.Type = 6, a.State =  12;
	if( Type == 0x0032 ) a.Type = 7, a.State =   8;
	if( Type == 0x0033 ) a.Type = 8, a.State =   6;

	if( Type == 0x0037 ) a.Type = 9, a.State =  50;
	if( Type == 0x0039 ) a.Type =10, a.State =  25;
	if( Type == 0x003A ) a.Type =11, a.State =  15;
//	if( Type == 0x0215 ) a.Type =13, a.State =  10;

        if (a.Type != -1) return a; // Ammo Set
        // Roll Again Slot
        a.Class = dNULLS;
        a.Type  = 0;
        a.Size  = 1;
        a.State = 0;

return a;
}

int ConvertDBMWeap(int Type) {
int a = -1;

  if (Type == 0x14) a = 0; // Flamer
  if (Type == 0x15) a = 1; // Large Laser
  if (Type == 0x16) a = 2; // Medium Laser
  if (Type == 0x18) a = 3; // Small Laser
  if (Type == 0x17) a = 4; // PPC

  if (Type == 0x1A) a = 5; // AC/2
  if (Type == 0x1C) a = 6; // AC/5
  if (Type == 0x19) a = 7; // AC/10
  if (Type == 0x1B) a = 8; // AC/20
  if (Type == 0x1D) a = 9; // MG

  if (Type == 0x24) a =10; // LRM 5
  if (Type == 0x1E) a =11; // LRM 10
  if (Type == 0x20) a =12; // LRM 15
  if (Type == 0x22) a =13; // LRM 20
  if (Type == 0x26) a =14; // SRM 2
  if (Type == 0x28) a =15; // SRM 4
  if (Type == 0x2A) a =16; // SRM 6

//  printf(">> %d\n",a);

return a;
}

MechCriticals ConvertDBMCrit(int Len, char *String) {
MechCriticals a;

a.Class = dACTUATOR;
a.Size  = 1;
a.State = 1;

  if (strcomp(String,"Shoulder")) a.Type = 0;
  if (strcomp(String,"Upper Arm Actuator")) a.Type = 1;
  if (strcomp(String,"Lower Arm Actuator")) a.Type = 2;
  if (strcomp(String,"Hand Actuator")) a.Type = 3;
  if (strcomp(String,"Hip")) a.Type = 4;
  if (strcomp(String,"Upper Leg Actuator")) a.Type = 5;
  if (strcomp(String,"Lower Leg Actuator")) a.Type = 6;
  if (strcomp(String,"Foot Actuator")) a.Type = 7;

  if (strcomp(String,"Life Support")) a.Type = 10;
  if (strcomp(String,"Cockpit")) a.Type = 11;
  if (strcomp(String,"Sensors")) a.Type = 12;

return a;
}


int ConvertDBMLoc (int Loc) {

	if( Loc == 0 ) return 5;
	if( Loc == 1 ) return 3;
	if( Loc == 2 ) return 7;
	if( Loc == 3 ) return 6;
	if( Loc == 4 ) return 2;
	if( Loc == 5 ) return 4;
	if( Loc == 7 ) return 0;
	if( Loc == 6 ) return 1;
/*
	if( Loc == 0x0A ) return 10;
	if( Loc == 0x0D ) return  9;
	if( Loc == 0x0F ) return 15;
	if( Loc == 0x10 ) return  8;
*/
return 1;
}

int readDBMCrits(class Mech &Mech, int Loc, int Slots, FILE *file) {
char String[200];
MechCriticals CritTemp;
int CritDex;
int i,j,k,l,m,n;
char RearMod;

m = 0;
j = 0;
Mech.CritSlot[Loc] = 0;

for (n=0;n<Slots-m;n++) {

// Start of Crit Read
  RearMod = 0;
  CritTemp.Class = 0;
  CritTemp.Type  = 0;
  

  i = readInt(file); // Length of Critical Name
  readStringLen(String,file,i); // reads any critical name
//  printf(">>%d %s",i,String);

  if (i > 0)
    CritTemp = ConvertDBMCrit(i,String);

    CritDex = readInt(file); // Self Indexing Number for Location
    readStringLen(String,file,0x10); // reads critical Misc.

    RearMod = readInt(file); // 0 Normal, -1/65535 RearMod
              readInt(file); // Misc Int

    i       = readInt(file); // Length of Critical Number
    readStringLen(String,file,i); // Refrences Weapon Table

    i       = readInt(file); // -1, for nothing or Weapon Type

//    printf("   %s      %d\n",String, i);

//  printf(" C:%d \n",i);

  if (i != -1 && i != 65535)
    CritTemp = ConvertDBMCritType(i,RearMod);

// End of Main Crit Read
//  if (CritTemp.Class != 0 && CritTemp.Type != 0)
    Mech.Crit[Loc][j] = CritTemp;

//  printf(" C:%d T:%d S:%d\n",CritTemp.Class,CritTemp.Type,CritTemp.Size);

  if (Mech.Crit[Loc][j].Size > 1) {
    l = Mech.Crit[Loc][j].Size;
//    printf(" C:%d \n",l);
    for (k=0;k<l-1;k++) {
      m++;
      // Reads Repeating Info
      i = readInt(file); // Length of Critical Name
      readStringLen(String,file,i); // reads any critical name

      CritDex = readInt(file); // Self Indexing Number for Location
      readStringLen(String,file,0x14); // reads critical Misc.

      i       = readInt(file); // Length of Critical Number
      readStringLen(String,file,i); // Refrences Weapon Table
      i       = readInt(file); // -1, for nothing or Weapon Type

      }
  }

  if (Mech.Crit[Loc][j].Class != 0) {// && Mech.Crit[Loc][j].Type != 0) {
    Mech.CritSlot[Loc] ++;
//    printf("-----> \n");
    j ++;
    }

}

//printf(">>>> C:%d \n",Mech.CritSlot[Loc]);
//getch();
return 0;
}

