///////////////////////////////////////////////////////////////////////////////
// Draw Functions
//
//

/////////////////////////////////////////////////////////////////////////////
// Graphics
//
//
//

BITMAP *bmp; // Alternate Screen For Double Buffering
BITMAP *MiniMap; // Mini Map Graphic

BITMAP *sprite[50];
BITMAP *mechsprite[MAXUNITS];
BITMAP *mechfallsprite[MAXUNITS];
BITMAP *itemsprite[MAXITEMS];
BITMAP *cursorsprite[2];
BITMAP *firesprite;
BITMAP *smokesprite;
BITMAP *bordersprite;  // Hex Border
BITMAP *highlightsprite;  // Target Highlight
BITMAP *effectsprite[16];

BITMAP *topbordersprite; // Metal band on top
BITMAP *sidebarsprite;   // Main Metal side border
BITMAP *sidebordersprite; // Metal side border
BITMAP *topbordertext; // Writes on a copy of topbordersprite - Less flicker

BITMAP *roadsprite[7];
BITMAP *riversprite[7];
BITMAP *bridgesprite[7];
BITMAP *shoresprite[7];
BITMAP *hill1sprite[7];
BITMAP *hill2sprite[7];

typedef struct Coords {
int x;
int y;
};

int  ProcFireMask (int Index,BITMAP *bmp);
Coords FireCoor[10][12];

int TerIndex [127];
int AltIndex [127];
int CondIndex[127];

//////////////////////////////////////////////////////////////////////////////
// Hex Variables
//
//
//

int HexWidth  = 16;
int HexHeight = 29;

// Hex Sprite

int SprWidth  = 32;
int SprHeight = 36;

// Mech Sprite

int UnitSprW     = 32;
int UnitSprH     = 36;

int SetSVGA();

int drawItem(Vector Vector, int Colour, int Type);
int drawHighLight       (int x, int y);
int drawLowLight        (int x, int y);

int drawRoad  (int x, int y);
int drawRiver (int x, int y);
int drawBridge(int x, int y);

int isRoad    (char a) {
if (a=='r' || a=='l' || (a>='0'&&a<='9') || a=='a') return 1;
return 0;
}

int isRiver   (char a) {
if (a=='w' || a=='l' || (a>='A'&&a<='J') || (a>='a'&&a<='j')) return 1;
return 0;
}

int isBridge  (char a) {
if ((a>='K'&&a<='T') || (a>='A'&&a<='J') || (a>='0'&&a<='9') || (a=='a'&&a<='j')) return 1;
return 0;
}


int drawHex (int x, int y) {
int i,j,k,l,m,w;
m = Map.Hex[x][y].Fire;
l = Map.Hex[x][y].Road;
w = Map.Hex[x][y].Type;
i = TerIndex[ Map.Hex[x][y].Type ];
j = AltIndex[ Map.Hex[x][y].Alt  ];
k = CondIndex[Map.Hex[x][y].Cond ];

int xr = x;
int yr = y;

x -= scrollx;
y -= scrolly;

if (x<0    || y<0   ) return 0; // Clip
if (x>Xmax || y>Ymax) return 0;

if (j!=-1 && w == 'w')
  draw_sprite(screen, sprite[j+30], x*HexWidth+globalx, y*HexHeight+globaly);
else {
if (j!=-1)
  draw_sprite(screen, sprite[j], x*HexWidth+globalx, y*HexHeight+globaly);
if (k!=-1) // Show Condition
  draw_sprite(screen, sprite[k], x*HexWidth+globalx, y*HexHeight+globaly);

if (Options.ShowHills == On)
  if (AltIndex[Map.Hex[xr][yr].Alt] <= 1) {
  if (AltIndex[Map.Hex[xr-2][yr  ].Alt] < AltIndex[Map.Hex[xr][yr].Alt] && xr >= 2                 )
    draw_sprite(screen , hill1sprite[1], x*HexWidth+globalx, y*HexHeight+globaly);
  if (AltIndex[Map.Hex[xr-1][yr+1].Alt] < AltIndex[Map.Hex[xr][yr].Alt] && xr >= 1       && yr < Ymax-1 )
    draw_sprite(screen , hill1sprite[2], x*HexWidth+globalx, y*HexHeight+globaly);
  if (AltIndex[Map.Hex[xr-1][yr-1].Alt] < AltIndex[Map.Hex[xr][yr].Alt] && xr >= 1       && yr >= 1   )
    draw_sprite(screen , hill1sprite[3], x*HexWidth+globalx, y*HexHeight+globaly);
  if (AltIndex[Map.Hex[xr+1][yr+1].Alt] < AltIndex[Map.Hex[xr][yr].Alt] && xr < Xmax-1   && yr < Ymax-1 )
    draw_sprite(screen , hill1sprite[5], x*HexWidth+globalx, y*HexHeight+globaly);
  if (AltIndex[Map.Hex[xr+1][yr-1].Alt] < AltIndex[Map.Hex[xr][yr].Alt] && xr < Xmax-1   && yr >= 1   )
    draw_sprite(screen , hill1sprite[4], x*HexWidth+globalx, y*HexHeight+globaly);
  if (AltIndex[Map.Hex[xr+2][yr  ].Alt] < AltIndex[Map.Hex[xr][yr].Alt] && xr < Xmax-2              )
    draw_sprite(screen , hill1sprite[6], x*HexWidth+globalx, y*HexHeight+globaly);
  } else {
  if (AltIndex[Map.Hex[xr-2][yr  ].Alt] < AltIndex[Map.Hex[xr][yr].Alt] && xr >= 2                 )
    draw_sprite(screen , hill2sprite[1], x*HexWidth+globalx, y*HexHeight+globaly);
  if (AltIndex[Map.Hex[xr-1][yr+1].Alt] < AltIndex[Map.Hex[xr][yr].Alt] && xr >= 1       && yr < Ymax-1 )
    draw_sprite(screen , hill2sprite[2], x*HexWidth+globalx, y*HexHeight+globaly);
  if (AltIndex[Map.Hex[xr-1][yr-1].Alt] < AltIndex[Map.Hex[xr][yr].Alt] && xr >= 1       && yr >= 1   )
    draw_sprite(screen , hill2sprite[3], x*HexWidth+globalx, y*HexHeight+globaly);
  if (AltIndex[Map.Hex[xr+1][yr+1].Alt] < AltIndex[Map.Hex[xr][yr].Alt] && xr < Xmax-1   && yr < Ymax-1 )
    draw_sprite(screen , hill2sprite[5], x*HexWidth+globalx, y*HexHeight+globaly);
  if (AltIndex[Map.Hex[xr+1][yr-1].Alt] < AltIndex[Map.Hex[xr][yr].Alt] && xr < Xmax-1   && yr >= 1   )
    draw_sprite(screen , hill2sprite[4], x*HexWidth+globalx, y*HexHeight+globaly);
  if (AltIndex[Map.Hex[xr+2][yr  ].Alt] < AltIndex[Map.Hex[xr][yr].Alt] && xr < Xmax-2              )
    draw_sprite(screen , hill2sprite[6], x*HexWidth+globalx, y*HexHeight+globaly);
  }

if (i!=-1)
  draw_sprite(screen, sprite[i], x*HexWidth+globalx, y*HexHeight+globaly);
  }

  if (Options.ShowShore == On)
  if (w == 'w') {
  if (Map.Hex[xr-2][yr  ].Type != 'w')
    draw_sprite(screen , shoresprite[1], x*HexWidth+globalx, y*HexHeight+globaly);
  if (Map.Hex[xr-1][yr+1].Type != 'w')
    draw_sprite(screen , shoresprite[2], x*HexWidth+globalx, y*HexHeight+globaly);
  if (Map.Hex[xr-1][yr-1].Type != 'w')
    draw_sprite(screen , shoresprite[3], x*HexWidth+globalx, y*HexHeight+globaly);
  if (Map.Hex[xr+1][yr+1].Type != 'w')
    draw_sprite(screen , shoresprite[5], x*HexWidth+globalx, y*HexHeight+globaly);
  if (Map.Hex[xr+1][yr-1].Type != 'w')
    draw_sprite(screen , shoresprite[4], x*HexWidth+globalx, y*HexHeight+globaly);
  if (Map.Hex[xr+2][yr  ].Type != 'w')
    draw_sprite(screen , shoresprite[6], x*HexWidth+globalx, y*HexHeight+globaly);
  }

if (isRiver (l)) drawRiver (x,y);
if (isRoad  (l)) drawRoad  (x,y);
if (isBridge(l)) drawBridge(x,y);

if (m=='f' || m=='F')
  draw_sprite(screen,firesprite, x*HexWidth+globalx, y*HexHeight+globaly);
if (m=='s' || m=='F')
  draw_sprite(screen,smokesprite, x*HexWidth+globalx, y*HexHeight+globaly);

if (Options.DrawGrid == On) {
  draw_sprite(screen,bordersprite, x*HexWidth+globalx, y*HexHeight+globaly); }

if (Options.AltitudeDisplay == On && MPH[Map.Hex[x][y].Alt] != 0) {
  textprintf(screen,font,x*HexWidth+globalx+2*HexWidth-14,y*HexHeight+globalx+HexHeight-12,Window.TextColour,"%2d",MPH[Map.Hex[x][y].Alt]); }

return 0;
}

int drawRoad  (int x, int y) {
  if (isRoad(Map.Hex[x-2+scrollx][y  +scrolly].Road)   && x >= 2         )    draw_sprite(screen , roadsprite[1], x*HexWidth+globalx, y*HexHeight+globaly);
  if (isRoad(Map.Hex[x-1+scrollx][y+1+scrolly].Road)   && x >= 1         )    draw_sprite(screen , roadsprite[2], x*HexWidth+globalx, y*HexHeight+globaly);
  if (isRoad(Map.Hex[x-1+scrollx][y-1+scrolly].Road)   && x >= 1 && y>= 1)    draw_sprite(screen , roadsprite[3], x*HexWidth+globalx, y*HexHeight+globaly);
  if (isRoad(Map.Hex[x+2+scrollx][y  +scrolly].Road)                     )    draw_sprite(screen , roadsprite[6], x*HexWidth+globalx, y*HexHeight+globaly);
  if (isRoad(Map.Hex[x+1+scrollx][y+1+scrolly].Road)                     )    draw_sprite(screen , roadsprite[5], x*HexWidth+globalx, y*HexHeight+globaly);
  if (isRoad(Map.Hex[x+1+scrollx][y-1+scrolly].Road)             && y>= 1)    draw_sprite(screen , roadsprite[4], x*HexWidth+globalx, y*HexHeight+globaly);
return 0;
}
int drawRiver (int x, int y) {
  if (isRiver(Map.Hex[x-2+scrollx][y  +scrolly].Road)  && x >= 2         )    draw_sprite(screen , riversprite[1], x*HexWidth+globalx, y*HexHeight+globaly);
  if (isRiver(Map.Hex[x-1+scrollx][y+1+scrolly].Road)  && x >= 1         )    draw_sprite(screen , riversprite[2], x*HexWidth+globalx, y*HexHeight+globaly);
  if (isRiver(Map.Hex[x-1+scrollx][y-1+scrolly].Road)  && x >= 1 && y>= 1)    draw_sprite(screen , riversprite[3], x*HexWidth+globalx, y*HexHeight+globaly);
  if (isRiver(Map.Hex[x+2+scrollx][y  +scrolly].Road)                    )    draw_sprite(screen , riversprite[6], x*HexWidth+globalx, y*HexHeight+globaly);
  if (isRiver(Map.Hex[x+1+scrollx][y+1+scrolly].Road)                    )    draw_sprite(screen , riversprite[5], x*HexWidth+globalx, y*HexHeight+globaly);
  if (isRiver(Map.Hex[x+1+scrollx][y-1+scrolly].Road)            && y>= 1)    draw_sprite(screen , riversprite[4], x*HexWidth+globalx, y*HexHeight+globaly);
return 0;
}
int drawBridge(int x, int y) {
  if (isBridge(Map.Hex[x-2+scrollx][y  +scrolly].Road) && x >= 2         )    draw_sprite(screen , bridgesprite[1], x*HexWidth+globalx, y*HexHeight+globaly);
  if (isBridge(Map.Hex[x-1+scrollx][y+1+scrolly].Road) && x >= 1         )    draw_sprite(screen , bridgesprite[2], x*HexWidth+globalx, y*HexHeight+globaly);
  if (isBridge(Map.Hex[x-1+scrollx][y-1+scrolly].Road) && x >= 1 && y>= 1)    draw_sprite(screen , bridgesprite[3], x*HexWidth+globalx, y*HexHeight+globaly);
  if (isBridge(Map.Hex[x+2+scrollx][y  +scrolly].Road)                   )    draw_sprite(screen , bridgesprite[6], x*HexWidth+globalx, y*HexHeight+globaly);
  if (isBridge(Map.Hex[x+1+scrollx][y+1+scrolly].Road)                   )    draw_sprite(screen , bridgesprite[5], x*HexWidth+globalx, y*HexHeight+globaly);
  if (isBridge(Map.Hex[x+1+scrollx][y-1+scrolly].Road)           && y>= 1)    draw_sprite(screen , bridgesprite[4], x*HexWidth+globalx, y*HexHeight+globaly);
return 0;
}



int drawMech(Vector Vector, int Colour, int Position) {
long ang = ((Vector.head-90)*64/90)<<16;
int x = (Vector.x-scrollx) * HexWidth;
int y = (Vector.y-scrolly) * HexHeight;

Colour %= MAXUNITS;
if (Vector.x-scrollx<0        || Vector.y-scrolly<0        ) return 0;
if (Vector.x-scrollx>MapWidth || Vector.y-scrolly>MapHeight) return 0;
if (Vector.x-scrollx>32       ) { // Special Case : Unit overdraws Right Panel
  return 0;}

if (Position == 1)
  rotate_sprite(screen , mechsprite[Colour], x+globalx, y+globaly, ang);
else
  rotate_sprite(screen , mechfallsprite[Colour], x+globalx, y+globaly, ang);

return 0;
}

int drawItem(Vector Vector, int Colour, int Type) {
long ang = ((Vector.head-90)*64/90)<<16;
int x = (Vector.x-scrollx) * HexWidth;
int y = (Vector.y-scrolly) * HexHeight;

if (Vector.x-scrollx<0    || Vector.y-scrolly<0   ) return 0;
if (Vector.x-scrollx>Xmax || Vector.y-scrolly>Ymax) return 0;

Colour%=4;

  rotate_sprite(screen , itemsprite[Colour], x+globalx, y+globaly, ang);

return 0;
}

/////////////////////////////////////////////////////////////////////////////
//
// Main Graphics Routine
//

int readSprites()
{
   BITMAP *the_image;
   PALLETE the_pallete;
   int i;
   int x,y;

//   set_color_depth(24);
   allegro_init();

for (i=0;i<127;i++) {
  TerIndex[i] = -1;
  AltIndex[i] = -1;
  CondIndex[i] = -1;
  }

TerIndex['t'] = 8;
TerIndex['T'] = 10;
TerIndex['%'] = 12;
TerIndex['U'] = 14;
TerIndex['j'] = 15;
TerIndex['J'] = 16;
TerIndex['V'] = 17;
TerIndex['R'] = 20; // Rubble
TerIndex['L'] = 21; // Light
TerIndex['M'] = 22; // Medium
TerIndex['H'] = 23; // Heavy
TerIndex['A'] = 24; // Armoured / Reinforced

TerIndex['p'] = 42;
TerIndex['w'] = -1;//30;

AltIndex['0'] = 0;
AltIndex['1'] = 1;
AltIndex['2'] = 2;
AltIndex['3'] = 3;
AltIndex['4'] = 4;

AltIndex['s'] = 5;
AltIndex['m'] = 6;
AltIndex['d'] = 7;

CondIndex['.'] = -1;
CondIndex['l'] = 40;
CondIndex['L'] = 41;
CondIndex['t'] = 43;
CondIndex['d'] = 45;
CondIndex['s'] = 46;
CondIndex['i'] = 47;
CondIndex['m'] = 48;
CondIndex['w'] = 49;

//   set_gfx_mode(GFX_VESA2L, 640, 480, 0, 0);
   SetSVGA();

   text_mode(-1); // Makes text Transparent

   for (i=0;i<50;i++) sprite[i]       = create_bitmap(SprWidth,SprHeight);

   for (i=0;i<MAXUNITS ;i++) mechsprite[i]   = create_bitmap(UnitSprW,UnitSprH);
   for (i=0;i<MAXUNITS ;i++) mechfallsprite[i]=create_bitmap(UnitSprW,UnitSprH);
   for (i=0;i<MAXITEMS ;i++) itemsprite[i]   = create_bitmap(UnitSprW,UnitSprH);
   for (i=0;i<2 ;i++) cursorsprite[i] = create_bitmap(SprWidth,SprHeight); // A little Extra
                      bordersprite    = create_bitmap(SprWidth,SprHeight);
                      highlightsprite = create_bitmap(SprWidth,SprHeight);
                      firesprite      = create_bitmap(SprWidth,SprHeight);
                      smokesprite     = create_bitmap(SprWidth,SprHeight);
                      topbordersprite = create_bitmap(640,24);
                      sidebarsprite   = create_bitmap(40,456);
                      sidebordersprite= create_bitmap(112,456);
                      topbordertext   = create_bitmap(640,24);
   for (i=0;i<16;i++) effectsprite[i] = create_bitmap(16,16);
   for (i=0;i<7 ;i++) roadsprite[i]   = create_bitmap(SprWidth,SprHeight);
   for (i=0;i<7 ;i++) riversprite[i]  = create_bitmap(SprWidth,SprHeight);
   for (i=0;i<7 ;i++) bridgesprite[i] = create_bitmap(SprWidth,SprHeight);
   for (i=0;i<7 ;i++) shoresprite [i] = create_bitmap(SprWidth,SprHeight);
   for (i=0;i<7 ;i++) hill1sprite [i] = create_bitmap(SprWidth,SprHeight);
   for (i=0;i<7 ;i++) hill2sprite [i] = create_bitmap(SprWidth,SprHeight);

   the_image = load_bitmap("sprite2a.pcx", the_pallete);

   if (Options.ShowSpritePCX == On)
     blit(the_image, screen, 0, 0, 0, 0, the_image->w, the_image->h);
   /* blit the image onto the screen */
   // Cheap for Now
   for (i=0;i<5;i++) // Get Ground
     blit(the_image, sprite[i],    SprWidth*i, SprHeight*0, 0, 0, SprWidth,SprHeight);
   for (i=0;i<3;i++) // Get Lower Ground
     blit(the_image, sprite[i+5],  SprWidth*i, SprHeight*1, 0, 0, SprWidth,SprHeight);

   for (i=0;i<5;i++) // Get High Water
     blit(the_image, sprite[i+30], SprWidth*i, SprHeight*2, 0, 0, SprWidth,SprHeight);
   for (i=0;i<3;i++) // Get Lower Water
     blit(the_image, sprite[i+35], SprWidth*i, SprHeight*3, 0, 0, SprWidth,SprHeight);

   for (i=0;i<5 ;i++) // Get Buildings
     blit(the_image, sprite[i+20], 160+SprWidth*i,SprHeight*4, 0, 0, SprWidth,SprHeight);

   for (i=0;i<10;i++) // Get Trees
     blit(the_image, sprite[i+8],  SprWidth*i, SprHeight*5, 0, 0, SprWidth,SprHeight);

   for (i=0;i<10;i++) // Get Conditions
     blit(the_image, sprite[i+40], SprWidth*i, SprHeight*6, 0, 0, SprWidth,SprHeight);

     blit(the_image, firesprite,   SprWidth*5, SprHeight*7, 0, 0, SprWidth,SprHeight); // Get Fire
     blit(the_image,smokesprite,   SprWidth*6, SprHeight*7, 0, 0, SprWidth,SprHeight); // Get Smoke

   // Finish with the Terrain Sprites
   destroy_bitmap(the_image);
   // Load 'Mech sprites
   the_image = load_bitmap("mechspr1.pcx", the_pallete);

//   getch();
 if (Options.ShowSpritePCX == On)
   blit(the_image, screen, 0, 0, 0, 0, the_image->w, the_image->h);
   for (i=0;i<4;i++)
     blit(the_image, mechsprite[i], 32*(i),0, 0, 0, 32, 36);

   for (i=0;i<4;i++)
     blit(the_image, mechfallsprite[i], 32*(i),72, 0, 0, 32, 36);
   for (i=0;i<4;i++)
     blit(the_image, mechsprite[i+4], 32*(i),0, 0, 0, 32, 36);

   for (i=0;i<4;i++)
     blit(the_image, mechfallsprite[i+4], 32*(i),72, 0, 0, 32, 36);

   for (i=0;i<4;i++)
     blit(the_image, itemsprite[i], 32*(i),108, 0, 0, 32, 36);

     blit(the_image, cursorsprite[0], 192 , 0, 0, 0, 32, 36);
     blit(the_image, bordersprite   , 192 ,36, 0, 0, 32, 36);
     blit(the_image, highlightsprite, 192 ,72, 0, 0, 32, 36);

//   draw_sprite(screen,bordersprite,500,300);
   /* destroy the bitmap */
   destroy_bitmap(the_image);
   the_image = load_bitmap("effects.pcx", the_pallete);

//   getch();
 if (Options.ShowSpritePCX == On)
   blit(the_image, screen, 0, 0, 0, 0, the_image->w, the_image->h);
   for (i=0;i<6;i++) {
     blit(the_image, effectsprite[i+1], 16*(i),0 , 0, 0, 16, 16);
     blit(the_image, effectsprite[i+7], 16*(i),16, 0, 0, 16, 16);
     }
//   getch();
   destroy_bitmap(the_image);
   // Load Road Icon sprites
   the_image = load_bitmap("rot2.pcx", the_pallete);
   if (Options.ShowSpritePCX == On)
     blit(the_image, screen, 0, 0, 0, 0, the_image->w, the_image->h);
   for (i=0;i<7;i++)
     blit(the_image, roadsprite[i]  , 32*(i), 0, 0, 0, 32, 36);
   for (i=0;i<7;i++)
     blit(the_image, bridgesprite[i], 32*(i),36, 0, 0, 32, 36);
   for (i=0;i<7;i++)
     blit(the_image, riversprite[i] , 32*(i),72, 0, 0, 32, 36);

   for (i=0;i<7;i++)
     blit(the_image, shoresprite[i] , 32*(i),108,0, 0, 32, 36);
   for (i=0;i<7;i++)
     blit(the_image, hill1sprite[i] , 32*(i),144,0, 0, 32, 36);
   for (i=0;i<7;i++)
     blit(the_image, hill2sprite[i] , 32*(i),180,0, 0, 32, 36);

   /* destroy the bitmap */
   destroy_bitmap(the_image);

// Top and side borders
   the_image = load_bitmap("spr\\top1.pcx", the_pallete);
   blit(the_image, topbordersprite  , 0, 0, 0, 0, 640, 24);
   /* destroy the bitmap */
   destroy_bitmap(the_image);

   the_image = load_bitmap("spr\\side1.pcx", the_pallete);
   blit(the_image, sidebordersprite , 0, 0, 0, 0, 112, 456);
   /* destroy the bitmap */
   destroy_bitmap(the_image);

   the_image = load_bitmap("spr\\sidetrim.pcx", the_pallete);
   blit(the_image, sidebarsprite , 0, 0, 0, 0,  20, 456);
   /* destroy the bitmap */
   destroy_bitmap(the_image);

//   draw_sprite( screen, sidebarsprite, 600, 24);
  draw_sprite( screen, sidebordersprite, 528, 24);
 
  bmp = create_system_bitmap(SCREEN_W, SCREEN_H);
    
   return 0;
}


int readMechSprite(int Colour,int Index,const char *String)
{
   BITMAP *the_image;
   BITMAP *firemask = create_bitmap(32,36);
   PALLETE the_pallete;
   char iString[80];
   int y = (Index/5) * 36;
   Index %= 5;

   sprintf(iString,"%s.pcx",String);
   the_image = load_bitmap(iString, the_pallete);

   if (the_image == NULL) return 2;//AbortGame(2); // Reverts to default
//   getch();
   if (Options.ShowSpritePCX == On)
     blit(the_image, screen, 0, 0, 0, 0, the_image->w, the_image->h);
//   for (i=0;i<4;i++)
     blit(the_image, mechsprite[Colour], Index*32, y, 0, 0, 32, 36);
     blit(the_image, firemask,128,0, 0, 0, 32, 36);

     ProcFireMask (Colour,firemask);
     destroy_bitmap(the_image);
     destroy_bitmap(firemask);
//   getch();
   return 0;
}

int readMechFallSprite(int Colour,int Index,const char *String)
{
   BITMAP *the_image;
   PALLETE the_pallete;
   char iString[80];
   int y = (Index/5) * 36;
   Index %= 5;

   sprintf(iString,"%s.pcx",String);
   the_image = load_bitmap(iString, the_pallete);

   if (the_image == NULL) return 2;//AbortGame(2); // Reverts to default
//   getch();
   if (Options.ShowSpritePCX == On)
     blit(the_image, screen, 0, 0, 0, 0, the_image->w, the_image->h);
     blit(the_image, mechfallsprite[Colour], Index*32, y, 0, 0, 32, 36);

     destroy_bitmap(the_image);

   return 0;
}

int drawMap() {
int x,y;
  for (y=0;y<16;y++)
    for (x=0;x<34;x++)
      if (Hex(x,y))
        drawHex(x+scrollx,y+scrolly);
return 0;
}

int drawUnits() {
int i;
vsync();
  for (i=0;i<Units;i++)
    drawHex (unit[i]->Vector.x,unit[i]->Vector.y);
  for (i=0;i<Units;i++)
//    drawMech(unit[i]->Vector,unit[i]->UnitColour,unit[i]->Position);
    unit[i]->drawUnit(0);

  if (Options.RedrawLowLights == On)
    for (i=0;i<Units;i++)
      if (unit[i]->Used == On)
        drawLowLight(unit[i]->Vector.x,unit[i]->Vector.y);

return 0;
}

int drawActiveUnits(int Side) {
int i;
vsync();

  if (Options.RedrawLowLights == On)
    for (i=0;i<Units;i++)
      if (unit[i]->Side != Side || unit[i]->Used == On  || unit[i]->Status == Off)
        drawLowLight(unit[i]->Vector.x,unit[i]->Vector.y);

    for (i=0;i<Units;i++)
      if (unit[i]->Side == Side && unit[i]->Used == Off && unit[i]->Status == On)
        drawHighLight(unit[i]->Vector.x,unit[i]->Vector.y);

return 0;
}

int drawScreen() {
int i;
BITMAP *ptr;

ptr = screen;
screen = bmp;

  drawMap();
  for (i=0;i<Items;i++)
    drawItem(Item[i].Vector,Item[i].Colour,Item[i].Type);
  for (i=0;i<Units;i++) 
    unit[i]->drawUnit(0);
    

  if (Options.RedrawLowLights == On)
    for (i=0;i<Units;i++)
      if (unit[i]->Used == On)
        drawLowLight(unit[i]->Vector.x,unit[i]->Vector.y);

//  draw_sprite( screen, topbordersprite ,   0,  0);
//  draw_sprite( screen, sidebarsprite, 528, 24);
//  blit(sidebarsprite, screen, 0, 0, 528, 24, 18, 456);
//  draw_sprite( screen, sidebordersprite, 528, 24);
  putString(LastString,LastColour);

  blit(sidebordersprite, screen, 0, 0, 528, 24, 112, 456);
  GenMiniMap();

screen = ptr;

vsync();
blit(bmp, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
      
return 0;
}

int drawCursor() {
int x = Cursor.x - scrollx;
int y = Cursor.y - scrolly;

  blit( screen, cursorsprite[1] ,x*HexWidth+globalx, y*HexHeight+globaly, 0, 0, 32, 36);
if (x <= MapWidth)
  draw_sprite( screen, cursorsprite[0], x*HexWidth+globalx, y*HexHeight+globaly);
return 0;
}

int blitCursor() {
int x = Cursor.x - scrollx;
int y = Cursor.y - scrolly;
  draw_sprite( screen, cursorsprite[1], x*HexWidth+globalx, y*HexHeight+globaly);
//if (Hex(Cursor.x,Cursor.y))
//  drawHex(Cursor.x,Cursor.y);
return 0;
}

int drawHighLight(int x, int y) {
  x -= scrollx;
  y -= scrolly;
  if (x >= 0 && x <= MapWidth && y >= 0 && y<=Ymax)
    draw_sprite(screen,highlightsprite, x*HexWidth+globalx, y*HexHeight+globaly);
return 0;
}

int drawLowLight(int x, int y) {
  x -= scrollx;
  y -= scrolly;
  if (x >= 0 && x <= MapWidth && y >= 0 && y<=Ymax)
    draw_sprite(screen,bordersprite, x*HexWidth+globalx, y*HexHeight+globaly);
return 0;
}

int ToggleGrid() {

Options.DrawGrid ^= 0x0001;

  drawScreen();

return Options.DrawGrid;
}

int drawArea(int x, int y) {

//draw Hex
//draw Units
return 0;
}


int drawWeaponFire(int Type,int Num, int x1,int y1, int x2, int y2) {
BITMAP *anim = create_bitmap(20,20);
int i;
int xi, yi;

int dx = x2-x1;
int dy = y2-y1;
int Angle = int(atan2(-dx,dy) * (180.0/PI) );

if (dx==0 && dy==0) return 1;

double Length = sqrt(dx*dx + dy*dy); // Distance in Pixels
double xinc = dx / Length;
double yinc = dy / Length;
double x=x1;
double y=y1;
//int WeaponSpeed[] = {45,30,22,15};
// Lsr Pls PPC Flm AMS AC  Gsr Flak Mis Roc HMis Art
int WeaponSpeed[] = {1,15,15,10,5,5,8,12,7,5,4,6,10};
//int WeaponSpeed[] = {30,20,15,10};
int AnimRest = 10;


// DX is timed by .577 as to simulate a Hex
//Angle = 180 - Angle; // 0 Top
//For Angle to = 0 at 150, Angle = 180-150 = 30
//if (Angle > 180) Angle -= 360;
//if (Angle <-180) Angle += 360;

Angle = (((Angle+90)*64)<<16)/90;
//y1 += int(8*sin((Angle+90)*PI/180));
int crx = int(16*(fabs(sin(Angle*PI/180))+fabs(cos(Angle*PI/180)) )) - 16;
//int cry = int(16*(cos(Angle*PI/180)))-16;
//int cry = int(16*(fabs(sin(Angle*PI/180))))-16;
//int cry = 0;
// CreateBitmap (xd,yd)
// Get x1,y1,x2,y2
// Draw
// Replace

//if (Type == 1 || Type == 2)  // Laser Beam / Pulse
  for (i=0;i<Length;i+=WeaponSpeed[Type]) {
    xi=int(x)-crx;  yi=int(y)-crx;
    blit( screen,anim ,xi-2, yi-2, 0, 0, 20, 20);
    rotate_sprite(screen ,effectsprite[Type], xi, yi, Angle);
    rest(AnimRest);  vsync();
    blit( anim,screen ,0, 0,xi-2, yi-2, 20, 20);
    x+=xinc*WeaponSpeed[Type];  y+=yinc*WeaponSpeed[Type];
    }
/*
if (Type == 3 || Type == 4)  // PPC / Fire
  for (i=0;i<Length;i+=WeaponSpeed[1]) {
    xi=int(x)-crx;  yi=int(y)-crx;
    blit( screen,anim ,xi-2, yi-2, 0, 0, 20, 20);
    rotate_sprite(screen ,effectsprite[1], xi, yi, Angle);
    rest(AnimRest);  vsync();
    blit( anim,screen ,0, 0,xi-2, yi-2, 20, 20);
    x+=xinc*WeaponSpeed[1];  y+=yinc*WeaponSpeed[1];
    }
if (Type == 6 || Type == 7) // AutoCannon
  for (i=0;i<Length;i+=WeaponSpeed[2]) {
    xi=int(x)-2-crx;  yi=int(y)-2-crx;
    blit( screen,anim ,xi-2, yi-2, 0, 0, 20, 20);
    rotate_sprite(screen ,effectsprite[2], xi, yi, Angle);
    rest(AnimRest);  vsync();
    blit( anim,screen ,0, 0,xi-2, yi-2, 20, 20);
    x+=xinc*WeaponSpeed[2];  y+=yinc*WeaponSpeed[2];
    }
if (Type == 9 || Type == 10) // Missiles
  for (i=0;i<Length;i+=WeaponSpeed[3]) {
    xi=int(x)-crx;  yi=int(y)-crx;
    blit( screen,anim ,xi-2, yi-2, 0, 0, 20, 20);
    rotate_sprite(screen ,effectsprite[3], xi, yi, Angle);
    rest(AnimRest);  vsync();
    blit( anim,screen ,0, 0,xi-2, yi-2, 20, 20);
    x+=xinc*WeaponSpeed[3];  y+=yinc*WeaponSpeed[3];
    }
*/
return 0;
}

int ProcFireMask (int Index,BITMAP *bmp) {
int x,y;
long col;
int halfx = 16;
int halfy = 18;

for (y=0;y<36;y++)
  for (x=0;x<32;x++) {
    col=getpixel(bmp,x,y);
//    if (col == 16711680) { // CT - Red
    if (col == makecol24(255,0,0)) {
      FireCoor[Index][0].x = x-halfx;
      FireCoor[Index][0].y = y-halfy;
      FireCoor[Index][1].x = x-halfx;
      FireCoor[Index][1].y = y-halfy;
      }
//    if (col == 65280) { // LT - Green
    if (col == makecol24(0,255,0)) {
      FireCoor[Index][3].x = x-halfx;
      FireCoor[Index][3].y = y-halfy;
      FireCoor[Index][7].x = x-halfx;
      FireCoor[Index][7].y = y-halfy;
      }
//    if (col == 255) { // RT - Blue
    if (col == makecol24(0,0,255)) {
      FireCoor[Index][2].x = x-halfx;
      FireCoor[Index][2].y = y-halfy;
      FireCoor[Index][6].x = x-halfx;
      FireCoor[Index][6].y = y-halfy;
      }
//    if (col == 16776960) { // LA - Yellow
    if (col == makecol24(255,255,0)) {
      FireCoor[Index][5].x = x-halfx;
      FireCoor[Index][5].y = y-halfy;
      }
//    if (col == 65535) { // RA - Cyan
    if (col == makecol24(0,255,255)) {
      FireCoor[Index][4].x = x-halfx;
      FireCoor[Index][4].y = y-halfy;
      }
//    if (col == 16777215) { // CTr - White
    if (col == makecol24(255,255,255)) {
      FireCoor[Index][8].x = x-halfx;
      FireCoor[Index][8].y = y-halfy;
      FireCoor[Index][9].x = x-halfx;
      FireCoor[Index][9].y = y-halfy;
      FireCoor[Index][10].x = x-halfx;
      FireCoor[Index][10].y = y-halfy;
      }
    }

return 0;
}

int SetSVGA() {
int i;
// Sets the Screen Mode
 set_color_depth(24);
// set_gfx_mode(GFX_VESA2L, 1024, 768, 0, 0);

// return 1;
 if(set_gfx_mode(GFX_SAFE, 640, 480, 0, 0)==0); //VESA2L 24bit
   else {
   set_color_depth(32);
   if (set_gfx_mode(GFX_SAFE, 640, 480, 0, 0) == 0); //VESA3 32bit
     else {
     Window.TextColour          = makecol16(EGA[0].r,EGA[0].g,EGA[0].b);
     Window.TextHighLightColour = makecol16(EGA[4].r,EGA[4].g,EGA[4].b);
     Window.BGColour            = makecol16(EGA[7].r,EGA[7].g,EGA[7].b);
     for (i=0;i<16;i++)
       EGAColour[i] = makecol16(EGA[i].r,EGA[i].g,EGA[i].b);
     set_color_depth(16);
     if (set_gfx_mode(GFX_SAFE, 640, 480, 0, 0) == 0);   //VESA2B 16bit
       else {
       set_color_depth(15);
       if (set_gfx_mode(GFX_SAFE, 640, 480, 0, 0) == 0); //VESA2B 15bit
         else AbortGame(7);
       }
     }
   }

return 0;
}

int GenMiniMap() {
int x,y,colour,colour2;
MiniMap = create_bitmap(Xmax,Ymax);
rectfill(MiniMap,0,0,Xmax,Ymax,EGAColour[ 2]);

  for (y=0;y<Ymax;y++)
    for (x=0;x<Xmax;x++)
      if (Hex(x,y)) {
        switch (Map.Hex[x][y].Alt) {
          case '0' : colour = EGAColour[ 2]; break;
          case '1' : colour = EGAColour[10]; break;
          case '2' : colour = EGAColour[14]; break;
          case '3' : colour = EGAColour[ 6]; break;
          case '4' : colour = EGAColour[ 8]; break;
          case '5' : colour = EGAColour[ 7]; break;
          case '6' : colour = EGAColour[15]; break;
          case '7' : colour = EGAColour[15]; break;
          case '8' : colour = EGAColour[15]; break;
          case '9' : colour = EGAColour[15]; break;
          case 's' : colour = EGAColour[ 3]; break;
          case 'm' : colour = EGAColour[ 9]; break;
          case 'd' : colour = EGAColour[ 1]; break;
          default  : colour = EGAColour[ 2]; break;
        }

        switch (Map.Hex[x][y].Type) {
          case '.' : colour2 = colour ; break;
          case 't' : colour2 = makecol24(0,110,0); break ;
          case 'T' : colour2 = makecol24(0,70,0); break ;
          case '%' : colour2 = EGAColour[ 7]; break ;
          default  : colour2 = colour ; break;
        }

        putpixel(MiniMap, x  , y, colour);
        putpixel(MiniMap, x+1, y, colour2);
        }

x = scrollx;
y = scrolly;

rect(MiniMap,x,y,x+34,y+16,EGAColour[ 4]);

stretch_sprite(screen, MiniMap, 532, 390, 105, 80);

return 0;      
}
