//#include <stdio.h>
//#include <conio.h>

// Binary to decimal
#define         b0      1
#define         b8      256
#define         b16     65536
#define         b24     16777216

typedef unsigned char  byte;
typedef unsigned short word;

enum {hNULLS,hWEAPON,hAMMO,hEQUIPMENT,hACTUATOR,hUNKNOWN,hWEAPONCONT};


int str[][5] =
 {{  0,  0, 0, 0, 0},
  {  5,  0, 0, 0, 0},
  { 10,  3, 2, 1, 2},
  { 15,  5, 4, 2, 3},
  { 20,  6, 5, 3, 4},
  { 25,  8, 6, 4, 6},
  { 30, 10, 7, 5, 7},
  { 35, 11, 8, 6, 8},
  { 40, 12,10, 6,10},
  { 45, 14,11, 7,11},
  { 50, 16,12, 8,12},
  { 55, 18,13, 9,13},
  { 60, 20,14,10,14},
  { 65, 21,15,10,15},
  { 70, 22,15,11,15},
  { 75, 23,16,12,16},
  { 80, 25,17,13,17},
  { 85, 27,18,14,18},
  { 90, 29,19,15,19},
  { 95, 30,20,16,20},
  {100, 31,21,17,21}};

int readStringLen(char *String, FILE *ReadFile, int Len)
{
int  i = 0;
for (i=0;i<Len;i++)
    String[i] = fgetc(ReadFile);

  String[i] = 0;
return i;
}

int readInt(FILE *ReadFile) {
int c;
c = fgetc(ReadFile);
c+= fgetc(ReadFile)*b8;
return c;
}

long int readLong(FILE *ReadFile) {
long int c;
c = fgetc(ReadFile);
c+= fgetc(ReadFile)*b8;
c+= fgetc(ReadFile)*b16;
c+= fgetc(ReadFile)*b24;
return c;
}

MechCriticals GetWeaponType( long Type );

int GetWeaponType ( int Type );
int ConvertHMPWeap( int Type );
int ConvertHMPLoc ( int Loc  );


// Main
int LoadHMP(class Mech &Mech, char *Name) {
int i,j,k,l,m,n;
byte  ch;
char  String[40];
FILE *HMP;

//HMP = fopen("lct.hmp","rb");
sprintf(String,"%s.hmp",Name);
HMP = fopen(String,"rb");

// Quit if no file found
if (HMP == NULL) return LoadDBM(Mech,Name);

// Variables in read order
int  Type, Tonnage;
//char Name [30];
//char Model[30];
int  Year;
int  Level;
long Cost;
int  BF2Length;
int  TechBase;
int  Legs; // Biped / Quad / LAM / Armless
int  ISType; // Standard / EndoSteel / Composite / Reinforced / Utility
int  EngineRating;
int  EngineType; // Fusion / XL / XXL / Compact / ICE
int  Walk;
int  Jump;
int  HS;
int  HSType; // Standard / Double / Compact / Laser
int  ArmourType; // Standard / FerroFibre / Stealth / Reactive / Reflective
		 // Heavy FF / Light FF / Patchwork

int  Armour[12]; // Armour on Mech
int  MType;      // Myomer Type - Standard / Triple Strength / Masc
int  NumWeap;    // Number of Weapons
//clrscr();
// get Header (5 char)
for (i=0;i<5;i++) {
  ch = fgetc(HMP);
  }

// get Type / Usage / Tonnage
readStringLen(String,HMP,14);

Type         = String[0];  // Mech Type
Mech.Tons    = String[12]; // Mech Tonnage

// Mech Name / Length
readStringLen(String,HMP,2); ch = String[0];
readStringLen(Mech.Name,HMP,ch);

// Mech Model Name / Length
readStringLen(String,HMP,2); ch = String[0];
readStringLen(Mech.Code,HMP,ch);

// Year Level Cost + BF2 String

//Year  = String[1]*b8  + String[0];
//Level = String[3]*b8  + String[2];
//Cost  = String[7]*b24 + String[6]*b16 + String[5]*b8 + String[4];
Year  = readInt (HMP);
Level = readInt (HMP);
Cost  = readLong(HMP);

readStringLen(String,HMP,26);

BF2Length = String[22];
// BF2 String (Not Used)
//printf("%d %d %d %d %d",String[21],String[22],String[23],String[24],String[26]);
//return 5;
readStringLen(String,HMP,BF2Length-2);
// Additional BF2 Data
//readStringLen(String,HMP,3);

//readStringLen(String,HMP,2);
// TechBase / Legs / IS
//readStringLen(String,HMP,6);

TechBase = readInt(HMP);
Legs     = readInt(HMP);
Mech.StructType   = readInt(HMP);

/*
for (i=0;i<6;i++) {
  printf(" %3d %c \n",String[i],String[i]);
  }
*/

EngineRating = readInt(HMP);
Mech.EngineType   = readInt(HMP);
Mech.Walk         = readInt(HMP);
Mech.Jump         = readInt(HMP);
Mech.HeatSinks    = readInt(HMP);
Mech.HeatSinkType = readInt(HMP);
Mech.ArmourType   = readInt(HMP);

// printf("%d %d %d %d %d\n",Legs,ISType,EngineRating,EngineType,Walk);
// Frontal Armour
for (i=0;i<8;i++) {
	      readInt(HMP);
  Armour[i] = readInt(HMP);
	      readInt(HMP);
  }

  Armour[8]  = readInt(HMP); // Rear Armour
  Armour[9]  = readInt(HMP);
  Armour[10] = readInt(HMP);

  Mech.MyomerType      = readInt(HMP);
  Mech.Weapons         = readInt(HMP);
  Mech.Armour[0]       = Armour[6];
  Mech.Armour[1]       = Armour[7];
  Mech.Armour[2]       = Armour[4];
  Mech.Armour[3]       = Armour[1];
  Mech.Armour[4]       = Armour[3];
  Mech.Armour[5]       = Armour[0];
  Mech.Armour[6]       = Armour[5];
  Mech.Armour[7]       = Armour[2];

  Mech.Armour[8 ]      = Armour[10];
  Mech.Armour[9 ]      = Armour[9 ];
  Mech.Armour[10]      = Armour[8 ];
  

//  printf("%d %d %d\n",Armour[3],Armour[2],Armour[1]);

// Temp Variables
  word WeapNumber;
  word WeapType;
  word WeapLoc;
  word WeapAmmo;
  word WeapU2;
  word WeapMLen;

// Calculated Variables
Mech.Type             = Legs;
Mech.TechBase         = Level;
Mech.RightHatchetType = 0;
Mech.LeftHatchetType  = 0;
Mech.CaseType         = 0;
Mech.CaseLoc          = 0;

//int  EngineType;
Mech.GyroType         = 0;
Mech.CockPitType      = 0;
Mech.SensorType       = 0;

//Mech.MyomerType;
//Mech.StructType;
//Mech.ArmourType;
//Mech.HeatSinkType;

Mech.NullSigType = 0;
Mech.BAPType     = 0;
Mech.ECMType     = 0;
Mech.C3Type      = 0;
Mech.AMSType     = 0;
Mech.MASCType    = 0;
Mech.CompType    = 0;
Mech.ARTType     = 0;

j=0;

  for(i=0;i<Mech.Weapons;i++ )
  {
    WeapNumber = readInt(HMP);
    WeapType   = readInt(HMP);
    WeapLoc    = readInt(HMP);
    WeapAmmo   = readInt(HMP);
    WeapU2     = readInt(HMP);
    WeapMLen   = readInt(HMP);

    readStringLen(String,HMP,WeapMLen);
//	CString type = GetWeaponType( WeaponType );
//	CString loc = GetWeaponLocation( WeaponLoc );

//    Weapon[i].Name = type;
//    Weapon[i].Location = loc;
//    Weapon[i].Ammo = WeaponAmmo;
//    Weapon[i].Number = WeaponNumber;

//    printf( "Weapon #%i : %i %s %s Ammo:%i ?%i %s\n", i, WeaponNumber, type, loc, WeaponAmmo, WeaponU2, Maker );
    WeapType = ConvertHMPWeap(WeapType);
    WeapLoc  = ConvertHMPLoc (WeapLoc );

    if (WeapNumber > 0)
      for (k=0;k<WeapNumber;k++) {
        Mech.Weapon[j] = WeaponTable[WeapType];
        Mech.Weapon[j].Loc  = WeapLoc;
        Mech.Weapon[j].State = 1;
        j ++;
        }

//    WeapState = 1; // Weapon Works
//    printf( "Weapon #%d : %d %d %d Ammo:%i %i %s\n", i, WeapLoc, WeapType, WeapNumber, WeapAmmo, WeapU2, String );
  }

  Mech.Weapons = j;

  // Read Crits
  // LA LT LL RA RT RL CT HD
  // All Locs have 12 crits
  // 12 X 8 = 96
  int   CritSlot[8];
  MechCriticals Crit[8][12];
  MechCriticals a;
  int   SlotCon[] = {5,3,7,4,2,6,0,1,0x0000}; // Convert .HMP format to .MEC

for (j=0;j<8;j++) {
  Mech.CritSlot[SlotCon[j]] = 0;
  m = 0;
  n = 0;
//  getch();
  for( i=0;i<12-m;i++)
  {
  a = GetWeaponType(readLong(HMP));

  if (a.Class != 0 || a.Type != 0) {
    Mech.Crit[SlotCon[j]][n] = a;
    Mech.CritSlot[SlotCon[j]] ++;

    if (Mech.Crit[SlotCon[j]][n].Size > 1) {
      l = Mech.Crit[SlotCon[j]][n].Size-1;
      for (k=0;k<l;k++) {
        m++; readLong(HMP); // Read Repeating Info
        }
      }

    n ++;
    }


  }
  }

//j = 4;
/*
for (i=0;i<CritSlot[j];i++)
  printf("%d %d %d %d\n",Crit[j][i].Class,Crit[j][i].Type,Crit[j][i].Size,Crit[j][i].State);
*/
fclose(HMP);
//for (i=0;i<8;i++)
//  printf("%d\n",Mech.CritSlot[i]);
  if (Mech.Crit[4][3].Class == 4 && Mech.Crit[5][3].Type == 3)
    Mech.RightArm.Length = 4;
    else
    if (Mech.Crit[4][2].Class == 4 && Mech.Crit[5][2].Type == 2)
      Mech.RightArm.Length = 3;
    else
      Mech.RightArm.Length = 2;

//if (Mech.Crit[5][3].Class == 4 && Mech.Crit[5][3].Type == 14) // Hatchet
  if (Mech.Crit[5][3].Class == 4 && Mech.Crit[5][3].Type == 3)
    Mech.LeftArm.Length = 4;
    else
    if (Mech.Crit[5][2].Class == 4 && Mech.Crit[5][2].Type == 2)
      Mech.LeftArm.Length = 3;
    else
      Mech.LeftArm.Length = 2;

  if (Mech.RightHatchetType == 1)
    Mech.RightArm.Length = 5;
  if (Mech.LeftHatchetType  == 1)
    Mech.LeftArm.Length = 5;

Mech.Struct[0] = 3;
Mech.Struct[1] = str[Mech.Tons/5][1];
Mech.Struct[2] = str[Mech.Tons/5][2];
Mech.Struct[3] = str[Mech.Tons/5][2];
Mech.Struct[4] = str[Mech.Tons/5][3];
Mech.Struct[5] = str[Mech.Tons/5][3];
Mech.Struct[6] = str[Mech.Tons/5][4];
Mech.Struct[7] = str[Mech.Tons/5][4];

  Mech.Run      = (Mech.Walk * 3 + 1) / 2;
  Mech.Position = 1; // Mech starts Standing, height equals 1+1 level
  Mech.Heat     = 0; // Mechs Start with no Heat
  Mech.Holding  =-1; // Mechs Start out not Holding Anything
  Mech.Carrying =-1; // Mechs Start out not Carrying any one
  Mech.Size     = 2; // Mech Height

  Mech.Status   = 1;
  Mech.Stacked  = Off;
  Mech.MASCNumber=3;

  Mech.EngineHits      = 0;
  Mech.GyroHits        = 0;
  Mech.SensorHits      = 0;
  Mech.LifeSupportHits = 0;

  Mech.RightArm.Shoulder = On;
  Mech.RightArm.UpperArm = On;
  if (Mech.RightArm.Length >= 3) Mech.RightArm.LowerArm = On;
  if (Mech.RightArm.Length == 4) Mech.RightArm.Hand     = On;
  Mech.LeftArm.Shoulder  = On;
  Mech.LeftArm.UpperArm  = On;
  if (Mech.LeftArm.Length >= 3) Mech.LeftArm.LowerArm  = On;
  if (Mech.LeftArm.Length == 4) Mech.LeftArm.Hand      = On;
  Mech.RightLeg.Hip      = On;
  Mech.RightLeg.UpperLeg = On;
  Mech.RightLeg.LowerLeg = On;
  Mech.RightLeg.Foot     = On;
  Mech.LeftLeg.Hip       = On;
  Mech.LeftLeg.UpperLeg  = On;
  Mech.LeftLeg.LowerLeg  = On;
  Mech.LeftLeg.Foot      = On;

return 0;
}

MechCriticals GetWeaponType( long Type )
{
int RearMod = 0;
MechCriticals a;
//printf("%ld\n",Type);

	if( Type & 65536 )
	{
	  Type -= 65536;
	  RearMod = -1;
	}

        a.Class = hNULLS;
        a.Type  = -1;
        a.Size  = 1;
        a.State = 0;
	if( Type == 0x00 ) Type = 0;

        if (a.Type != -1) {a.Type = 0; return a;} // Null Set

        a.Class  = hACTUATOR;
        a.Size   = 1;
        a.State  = 1;

	if( Type == 0x01 ) a.Type = 0;
	if( Type == 0x02 ) a.Type = 1;
	if( Type == 0x03 ) a.Type = 2;
	if( Type == 0x04 ) a.Type = 3;
	
	if( Type == 0x05 ) a.Type = 4;
	if( Type == 0x06 ) a.Type = 5;
	if( Type == 0x07 ) a.Type = 6;
	if( Type == 0x08 ) a.Type = 7;

	if( Type == 0x0C ) a.Type =10;
	if( Type == 0x0D ) a.Type =12;
	if( Type == 0x0E ) a.Type =11;

	if( Type == 0x0F ) a.Type = 8;
	if( Type == 0x10 ) a.Type = 9;

        if (a.Type != -1) return a; // Actuator Set

        a.Class  = hEQUIPMENT;
        a.State  = 1;
	if( Type == 0x09 ) a.Type = 0, a.Size = 1;
	if( Type == 0x0A ) a.Type = 0, a.Size = 3; // Can Only Handle StarLeague
	if( Type == 0x0B ) a.Type = 1, a.Size = 1;

        if (a.Type != -1) return a; // Equipment Set

        a.Class = hWEAPON;
        a.State = RearMod;
	if( Type == 0x35 ) a.Type = 0, a.Size = 1;
	if( Type == 0x39 ) a.Type = 3, a.Size = 1;
	if( Type == 0x37 ) a.Type = 1, a.Size = 2;
	if( Type == 0x38 ) a.Type = 2, a.Size = 1;
	if( Type == 0x3A ) a.Type = 4, a.Size = 3;

	if( Type == 0x3E ) a.Type = 5, a.Size = 1;
	if( Type == 0x3F ) a.Type = 6, a.Size = 4;
	if( Type == 0x40 ) a.Type = 7, a.Size = 7;
	if( Type == 0x41 ) a.Type = 8, a.Size =10;
	if( Type == 0x4F ) a.Type = 9, a.Size = 1;

	if( Type == 0x60 ) a.Type =10, a.Size = 1;
	if( Type == 0x61 ) a.Type =11, a.Size = 2;
	if( Type == 0x62 ) a.Type =12, a.Size = 3;
	if( Type == 0x63 ) a.Type =13, a.Size = 5;

	if( Type == 0x67 ) a.Type =14, a.Size = 1;
	if( Type == 0x68 ) a.Type =15, a.Size = 1;
	if( Type == 0x69 ) a.Type =16, a.Size = 2;

        if (a.Type != -1) return a; // Weapon Set

	Type &= 0xFFFF;

        a.Class = hAMMO;
        a.Size  = 1;

	if( Type == 0x01f0 ) a.Type = 5, a.State =  24;
	if( Type == 0x01f1 ) a.Type = 6, a.State =  12;
	if( Type == 0x01f2 ) a.Type = 7, a.State =   8;
	if( Type == 0x01f3 ) a.Type = 8, a.State =   6;
	if( Type == 0x01ce ) a.Type = 0, a.State =  45;
	if( Type == 0x01d0 ) a.Type = 2, a.State =  10;
	if( Type == 0x01cf ) a.Type = 1, a.State =  20;
	if( Type == 0x01d1 ) a.Type = 3, a.State =   5;
	if( Type == 0x01df ) a.Type = 4, a.State = 200;
	if( Type == 0x01f7 ) a.Type = 9, a.State =  50;
	if( Type == 0x01f8 ) a.Type =10, a.State =  25;
	if( Type == 0x01f9 ) a.Type =11, a.State =  15;
	if( Type == 0x0215 ) a.Type =13, a.State =  10;;

        if (a.Type != -1) return a; // Ammo Set
        // Roll Again Slot
        a.Class = hNULLS;
        a.Type  = 0;
        a.Size  = 1;
        a.State = 0;

return a;
}

int ConvertHMPWeap(int Type) {
int a;

	if( Type == 0x35 ) a = 0;
	if( Type == 0x39 ) a = 3;
	if( Type == 0x37 ) a = 1;
	if( Type == 0x38 ) a = 2;
	if( Type == 0x3A ) a = 4;

	if( Type == 0x3E ) a = 5;
	if( Type == 0x3F ) a = 6;
	if( Type == 0x40 ) a = 7;
	if( Type == 0x41 ) a = 8;
	if( Type == 0x4F ) a = 9;

	if( Type == 0x60 ) a =10;
	if( Type == 0x61 ) a =11;
	if( Type == 0x62 ) a =12;
	if( Type == 0x63 ) a =13;

	if( Type == 0x67 ) a =14;
	if( Type == 0x68 ) a =15;
	if( Type == 0x69 ) a =16;

return a;
}

int ConvertHMPLoc (int Loc) {

	if( Loc == 1 ) return 5;
	if( Loc == 2 ) return 3;
	if( Loc == 3 ) return 7;
	if( Loc == 4 ) return 4;
	if( Loc == 5 ) return 2;
	if( Loc == 6 ) return 6;
	if( Loc == 7 ) return 0;
	if( Loc == 8 ) return 1;
	if( Loc == 0x0A ) return 10;
	if( Loc == 0x0D ) return  9;
	if( Loc == 0x0F ) return 15;
	if( Loc == 0x10 ) return  8;

return 1;
}




