///////////////////////////////////////////////////////////////////////////////
//
//  MechWar 3025 ver.1 Beta
//
//
//  Copyright (C) 2000-2002 Gregg Henry (juton@webave.com)
//
//
//  This program is free software; you can redistribute it and/or modify it 
//  under the terms of the GNU General Public License as published by the Free 
//  Software Foundation; either version 2 of the License, or (at your option) 
//  any later version.
// 
//  This program is distributed in the hope that it will be useful, but 
//  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
//  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
//  for more details.
//
#include <stdio.h>
#include <conio.h>
#include <math.h>
#include <stdlib.h>
#include <time.h>
//#include <bios.h>

#include "allegro.h"

#define         Hex(x,y)        (((y & 0x0001) + (x & 0x0001) + 1) & 0x0001)
#define         aHex(x,y)      !(((y & 0x0001) + (x & 0x0001) + 1) & 0x0001)
#define         checkFile(a,b)    if (a==NULL) AbortGame(b)
#define         rad             180/PI

int readString(char *String, FILE *ReadFile);

#include "weapdat2.cpp"
#include "struct.cpp"
#include "data1.cpp"

//#include "network.hpp"

int SetMovementCost();

int drawScreen   ();
int GenMiniMap   ();
int loadUnits    ();
int LoadMap      (char *MapName, OldMapData *Loadmap);
int LoadMEP      (class Mech &Mech, char *Name);
int LoadHMP      (class Mech &Mech, char *Name);
int LoadDBM      (class Mech &Mech, char *Name);

int putString    (char *String, int Colour);
int StringLength (char *String);
int getInfo      (int Index);
int getUnit      (int x, int y);
int getTarget    (int );
int getAttackAngle (Vector Attacker, Vector Target);
int getDamageAngle (Vector Attacker, Vector Target);
int getFacing    (int Angle);
int getkey       ();
char isDigit     (char input);
char isLetter    (char input);

int ExitGame     (int Error);
int AbortGame    (int Error);

int setDefaultOptions();
int InitiativeGame   ();

int counterAdvance(Vector *Vector);
int getMoveCost(Vector Vector, int head);

int AIMovePhase     (class Unit *AI);
int AIReactionPhase (class Unit *AI);
int AIWeaponPhase   (class Unit *AI);
int AIPhysicalPhase (class Mech *AI);

#include "los7.cpp"
//#include "mechread.cpp"
#include "draw.cpp"
#include "phases.cpp"
#include "funcs.cpp"
#include "aimove.cpp"

#include "mechload.cpp"
#include "mechphas.cpp"
#include "mechfunc.cpp"

#include "mepload.cpp"
#include "hmpload.cpp"
#include "dbmload.cpp"

#include "vecload.cpp"
#include "vecphas.cpp"
#include "vecfunc.cpp"

#include "infload.cpp"
#include "infphas.cpp"
#include "inffunc.cpp"

#include "elmload.cpp"
#include "elmphas.cpp"
#include "elmfunc.cpp"

#include "readopts.cpp"
//#include "airad.cpp"
//#include "aiweap.cpp"
//#include "ai.cpp"
#include "mechai.cpp"
#include "mechaiwp.cpp"
#include "vecai.cpp"
#include "vecaiwp.cpp"
#include "infai.cpp"
#include "infaiwp.cpp"
#include "elmai.cpp"
#include "elmaiwp.cpp"

/////////////////////////////////////////////////////////////////////////////
//
//  Is it Hex data or Elevation Data
//
//  IsHex = (Y & 0x0001 + X & 0x0001) & 0x0001;
//

////////////////////////////////////////////////////////////////////////////
//
//   330   30
// 270   *    90
//   210   150
//

int main(int argc, char *argv[])
{
int Roll[MAXUNITS],Order[MAXUNITS],iOrder[MAXUNITS];
int a,Turn = 0;
int Max;
int x,y;
int i,j;
int Iterations;
int ActiveSide;
int Sides;
textbarx = 1;
textbary = 1;

//printf("MMM>> %d\n",getkey());

//return 0;
//randomize();
srand(time(0));
//printf(" %d \n",time(0));

//LoadMEP(Mech[2],"MEC\\QKD-5A");
//return 0;

SetMovementCost();

ReadWeaponType("weapon.dat");
ReadAmmoType  ("ammo.dat"  );
/*
init_ParallelPort();
receive_Maps();
*/
readMission(argc, argv[1]);
setDefaultOptions(); // Incase something happens in readOptions
readOptions(argc, argv[1]);
setOptions();
readSprites();
loadMaps();
loadUnits();
initMapVariables();

set_uformat(U_ASCII); // So the special characters display correctly

char String[40];

/*
HexWidth  =  4;
HexHeight =  7;
HexScaleX =  8;
HexScaleY =  9;
MapHexX   = 68;
MapHexY   = 32;
MechScale = long((1<<16)*.25);
*/

Cursor.x=2;
Cursor.y=2;

CurrentUnit = 0;

//unit[0]->Pilot.Target          = 1;

Window.TextColour          = makecol24(EGA[0].r,EGA[0].g,EGA[0].b);
Window.TextHighLightColour = makecol24(EGA[4].r,EGA[4].g,EGA[4].b);
Window.BGColour            = makecol24(EGA[7].r,EGA[7].g,EGA[7].b);

// AI Initialization
SetAISpeed();

AISetUp(unit[1]);

// Spacing of the sprites
globalx = -15;
globaly =  16;

scrollx = 0;
scrolly = 0;

ItemLimit = 4;
drawScreen();

install_mouse();
install_timer();
install_keyboard();
//clear(screen);
//getch();
//transmit_byte ( 13 );
//transmit_HexData(Map.Hex[0][0]);
/*
Map.x1 =  0;
Map.y1 =  0;
Map.x2 = 34;
Map.y2 = 16;
*/
//transmit_MapData(Map);

Options.MouseMove = On;

if (Options.InitiativeBySide == On) InitiativeGame();

  Sides = getSides();

while (AssessVictory(Sides) == -1) {

  drawScreen();

  for (i=0;i<Units;i++)
    Roll[i] = unit[i]->InitiativePhase();

  for (i=0;i<Units;i++) {
    Max = -12;
    for (j=0;j<Units;j++)
      if (Roll[j] >= Max) {
        Order[i] = j;
        iOrder[Units-i-1] = j;
        Max = Roll[j];
        }
    Roll[Order[i]] = 0;
    }

// Movement Phase
  for (a=0;a<Units;a++)
    unit[iOrder[a]]->MovePhase();

  for (a=0;a<Units;a++) unit[a]->Used = Off;
  drawScreen();

// Reaction Phase
  for (a=0;a<Units;a++)
    if (Options.CompressReactionPhase != On)
      unit[Order[a]]->ReactionPhase();

  for (a=0;a<Units;a++) unit[a]->Used = Off;
  drawScreen();

// Weapon Phase
  for (a=0;a<Units;a++) {
    if (Options.CompressReactionPhase == On)
      unit[Order[a]]->ReactionPhase();
    unit[Order[a]]->WeaponPhase();
    }

// Resolve Weapon Fire
  for (a=0;a<Units;a++)
    unit[Order[a]]->ResolveWeaponFire();

  for (a=0;a<Units;a++) unit[a]->Used = Off;
  drawScreen();

// Physical Phase
  for (a=0;a<Units;a++)
    unit[Order[a]]->PhysicalPhase();

// Resolve Physical Attacks
  for (a=0;a<Units;a++)
    unit[Order[a]]->ResolvePhysicalAttacks();

  for (a=0;a<Units;a++) unit[a]->Used = Off;
  drawScreen();

// Heat Phase
  for (a=0;a<Units;a++)
    unit[Order[a]]->HeatPhase();
// End Phase
  for (a=0;a<Units;a++)
    unit[Order[a]]->EndPhase();

  SpreadFire();
  }

//  Mech[0].ShowCrits();
//  Mech[1].Show();
//rectfill(screen,100,120,500,360,makecol24(171,171,171));
//getch();
//ExitGame(0);

   /* load the datafile into memory */
/*
   datafile = load_datafile("fnt\\pc1.dat");
//   datafile = load_datafile("font\\example.dat");
   if (!datafile) {
      allegro_exit();
      printf("Error loading %s!\n\n", buf);
      return 3;
   }
   FONT *afont = (FONT *)datafile[0].dat;
*/
   /* and use the font from the datafile */

//textprintf(screen,afont,20,20,makecol24(171,171,171),"ABCDEFG Medium Laser");

   /* unload the datafile when we are finished with it */
//   unload_datafile(datafile);

//getch();
allegro_exit();
SaveBattleReport(2,AssessVictory(2));
getch();
//clrscr();
//textattr(2);
printf("MechWar 3025 ver.10 Beta\r\n");

return 0;
}
END_OF_MAIN();

int ExitGame     (int Error) {
/*Prompt*/
//Set Background Attributes to 07
BITMAP *block;
block = create_bitmap(250,100);
char ch;

blit    (screen,block,180,180,0,0,250,100);

rectfill(screen,180,180,400,260,Window.BGColour);
textprintf(screen,font,200,200,Window.TextColour,"Quit ? (Y/N)");
ch = getkey();

blit    (block,screen,0,0,180,180,250,100);

if (ch == 'y' || ch == 'Y') {
// SetText and outprint
//  textmode(C80);
  allegro_exit();
//  clrscr();
//  textattr(2);
  printf("MechWar 3025 ver.10 Beta\r\n");
//  printf("1 %d 2 %d 3 %d \n",Mech[0].CalcBV(1),Mech[1].CalcBV(1),Mech[2].CalcBV(1));
  exit(Error);
  }
return 0;
};

int AbortGame(int Error) {

// 1 : No Weapon.Dat
// 2 : No Ammo.Dat
// 3 : No Mission.Dat
// 4 : Bad/Missing Map
// 5 : Bad/Missing MEC
// 7 : NonCompatable Video Card
  allegro_exit();
//  clrscr();
//  textattr(4);
  switch (Error) {
  case 1  : printf("CRITICAL ERROR %d !\r\nBad or Missing WEAPON.DAT  \r\n",Error); break;
  case 2  : printf("CRITICAL ERROR %d !\r\nBad or Missing AMMO.DAT    \r\n",Error); break;
  case 3  : printf("CRITICAL ERROR %d !\r\nBad or Missing MISSION.DAT \r\n",Error); break;
  case 4  : printf("CRITICAL ERROR %d !\r\nBad or Missing .MAP File   \r\n",Error); break;
  case 5  : printf("CRITICAL ERROR %d !\r\nBad or Missing .MEC File   \r\n",Error); break;
  case 6  : printf("CRITICAL ERROR %d !\r\nBad or Missing OPTIONS.DAT \r\n",Error); break;
  case 7  : printf("CRITICAL ERROR %d !\r\nCompatible Video Card not detected \r\n",Error); break;
  case 8  : printf("CRITICAL ERROR %d !\r\nBad or Missing .INF File   \r\n",Error); break;
  case 9  : printf("CRITICAL ERROR %d !\r\nBad or Missing .ELM File   \r\n",Error); break;
  default : printf("CRITICAL ERROR %d !\r\n",Error); break;
  }
  exit(0);

return 127;
}

int readString(char *String, FILE *ReadFile)
{
char ch = 1;
int  i = 0;
while (ch != 10 && ch != 13 && ch !=0x0000) {
  ch = fgetc(ReadFile);
  String[i] = ch;
  i++;
  }

  String[i-1] = 0;
return i;
}

int setDefaultOptions() {

Options.ChargeMoves = On;
Options.InitiativePhase = On;
Options.MovePhase = On;
Options.ReactionPhase = On;
Options.WeaponPhase = On;
Options.PhysicalPhase = On;
Options.HeatPhase = On;
Options.EndPhase = On;
Options.DrawGrid = Off;
Options.HighLight = On;
Options.CreateFire = On;
Options.CentreMap  = Off;
Options.ShowWeaponFire = On;
Options.AmmoExplosions = On;
Options.AmmoConsumption = On;
Options.ModeratedAmmoExplosions = Off;
Options.SaveBattleReport  = On;
Options.ShowTargetTerrain = On;
Options.Stacking       = On;
Options.FloatingCrits  = On;
Options.TransferDamage = On;
Options.GlancingHits   = Off;
Options.Retreat        = Off;
Options.AltitudeDisplay= Off;
Options.FastAI         = Off;

Options.LOSBlock       = Off;
Options.ElectronicLOS  = Off;
Options.LinearGunnery  = Off;
Options.LinearPiloting = Off;
Options.ExtremeRange   = Off;

Options.CriticalHits               = On;
Options.SimultaneousWeaponFire     = Off;
Options.SimultaneousPhysicalAttacks= Off;
Options.InitiativeBySide           = Off;
Options.CompressReactionPhase      = Off;

Options.RedrawLowLights            = On;
Options.AimedShots                 = On;
Options.CalledShots                = On;
Options.AutoPick                   = Off;
Options.MASCLocks                  = On;
Options.HeadShots                  = On;

Options.GlancingHeadHits           = Off;
Options.AllSprint                  = Off;
Options.AllEvade                   = Off;

Options.ShowShore                  = On;
Options.ShowHills                  = On;
Options.TwentyPointFalls           = On;
Options.AngleOfAttack              = Off;
Options.HexFacings                 = On;
Options.MoveUnitsBySide            = On;
Options.MissileBonus               = Off;
Options.MovementDice               = On;

Options.ShowSpritePCX              = Off;

return 0;
}

int InitiativeGame() {
int a,b,c,i,j,k;
int Sides;
int Roll[8],Order[8],iOrder[8];
int Turn = 0;
int Max;
int ActiveSide;
c=0;
//allegro_exit();
//for (i=0;i<Sides;i++)
//  textprintf(screen,font,20,20+i*10,EGAColour[15],">> %d %d",Order[i],Roll[i]);

  Sides = getSides();

while (AssessVictory(Sides) == -1) {
  drawScreen();

  for (a=0;a<Units;a++) unit[a]->Used = Off;

  for (i=0;i<Sides;i++)
    Roll[i] = InitiativeSide(i);

  for (i=0;i<Sides;i++) {
    Max = 0;
    for (j=0;j<Sides;j++)
      if (Roll[j] >= Max) {
        Order[i] = j;
        iOrder[Sides-i-1] = j;
        Max = Roll[j];
        }
    Roll[Order[i]] = 0;
//    Roll[i] = 0;
    }

// Movement Phase
  for (a=0;a<Units;a++) unit[a]->Used = Off;
//  drawUnits();
  c = 0;
  k = 0;
  j = 0;

  if (Options.MovePhase == On)
  while (getActiveUnits() > 0) {

    ActiveSide = iOrder[c]+1;
  if (Options.MoveUnitsBySide == On)
    ActiveSide = iOrder[k]+1;

//    for (j=0;j<getSideRatio(ActiveSide);j++) {
    if (getActiveUnitsSide(ActiveSide)) {
      drawActiveUnits(ActiveSide);
      i = getActiveUnit(ActiveSide); // Restrict Target to Side
      drawUnits();
      unit[i]->MovePhase();
      unit[i]->Used = On;
      }

    j++;
    if (j >= getSideRatio(ActiveSide)) {
      c++;
      c>=Sides?c=0:c;
      }
    if (getActiveUnitsSide(ActiveSide) == 0) k++;
  }

  for (a=0;a<Units;a++) unit[a]->Used = Off;
  drawUnits();

  c = 0;
  k = 0;
  j = 0;
// Reaction Phase
  if (Options.ReactionPhase == On)
  if (Options.CompressReactionPhase != On)
    while (getActiveUnits() > 0) {
      ActiveSide = Order[c]+1;
    if (Options.MoveUnitsBySide == On)
      ActiveSide = Order[k]+1;
      for (j=0;j<getSideRatio(ActiveSide);j++) {
        drawActiveUnits(ActiveSide);
        i = getActiveUnit(ActiveSide); // Restrict Target to Side
        drawUnits();
        unit[i]->ReactionPhase();
        unit[i]->Used = On;
        }
      j++;
      if (j >= getSideRatio(ActiveSide)) {
        c++;
        c>=Sides?c=0:c;
        }
      if (getActiveUnitsSide(ActiveSide) == 0) k++;
      }

  for (a=0;a<Units;a++) unit[a]->Used = Off;
  drawUnits(); // Refresh Mechs

  c=0;
  k=0;
  j=0;
// Weapon Phase
  if (Options.WeaponPhase == On)
  while (getActiveUnits() > 0) {
    ActiveSide = Order[c]+1;
  if (Options.MoveUnitsBySide == On)
    ActiveSide = Order[k]+1;
//    while (getSide)
//    for (j=0;j<getSideRatio(ActiveSide);j++) {
    if (getActiveUnitsSide(ActiveSide)) {
      drawActiveUnits(ActiveSide);
      i = getActiveUnit(ActiveSide); // Restrict Target to Side
      drawUnits();
      if (Options.CompressReactionPhase == On)
        unit[i]->ReactionPhase();
      unit[i]->WeaponPhase();
      unit[i]->Used = On;
      }
    j++;
    if (j >= getSideRatio(ActiveSide)) {
      c++;
      c>=Sides?c=0:c;
      }
    if (getActiveUnitsSide(ActiveSide) == 0) k++;
    }

// Resolve Weapon Fire
  for (a=0;a<Units;a++)
    unit[a]->ResolveWeaponFire();

  for (a=0;a<Units;a++) unit[a]->Used = Off;
  drawUnits();

  c=0;
// Physical Phase

  k = 0;
  for (i=0;i<Units;i++)
    for (j=0;j<Units;j++)
      if (unit[i]->Side != unit[j]->Side)
        if (1 == doLos(unit[i]->Vector.x,unit[i]->Vector.y,unit[j]->Vector.x,unit[j]->Vector.y) )
          k++;
        else
          unit[i]->Used = On;

  if (Options.PhysicalPhase == On)
  if (k > 0) {
    k = 0;
  while (getActiveMechs() > 0) {
    ActiveSide = Order[c]+1;
  if (Options.MoveUnitsBySide == On)
    ActiveSide = Order[k]+1;
    for (j=0;j<getMechSideRatio(ActiveSide);j++) {
      drawActiveUnits(ActiveSide);
      i = getActiveUnit(ActiveSide); // Restrict Target to Side
      drawUnits();

      unit[i]->PhysicalPhase();
      unit[i]->Used = On;
      }

    j++;
    if (j >= getMechSideRatio(ActiveSide)) {
      c++;
      c>=Sides?c=0:c;
      }
    if (getActiveMechsSide(ActiveSide) == 0) k++;
    }
  }

// Resolve Physical Attacks
  for (a=0;a<Units;a++)
    unit[a]->ResolvePhysicalAttacks();

  for (a=0;a<Units;a++) unit[a]->Used = Off;
  drawUnits();

// Heat Phase
  for (a=0;a<Units;a++)
    unit[a]->HeatPhase();
// End Phase
  for (a=0;a<Units;a++)
    unit[a]->EndPhase();

  SpreadFire();

  }

allegro_exit();
SaveBattleReport(2,AssessVictory(2));
getch();
//clrscr();
//textattr(2);
printf("MechWar 3025 ver.10 Beta\r\n");

exit(0);
return 1;
}
