/////////////////////////////////////////////////////////////////////////////
// Mech Phases
//
//
/////////////////////////////////////////////////////////////////////////////
// Initiative Phase
//
//

int Mech::InitiativePhase () {
if (Options.InitiativePhase == Off) return 0;
int Init = roll2d6 + Pilot.Reflexes;
return Init;
}


////////////////////////////////////////////////////////////////////////////
// Movement Phase
//
//
//

int Mech::MovePhase()
{
// Select Move Options

// Player 1's Turn
// Walk 4 Run 6 Jump 6 ? info
// (Move) ?Info

if (Options.MovePhase == Off || Immobile == On || Status == Off) return 0;
if (Pilot.AIMovePhase == On) return AIMovePhase() ; // AI Control

//drawScreen();

char iString[80],String[80],wString[15],rString[15],sString[15],eString[15],jString[15],aString[15];
char mString[15];
int i;

Reversed = 0;
HeatTurn = 0; // For Heat Generated by moving through fire

if (validQuad()) { // Quad Mech Bonus
  Pilot.FallBonus = 2;
  Pilot.StandBonus = 4;
  Pilot.LatShift = On;
  }
else {
  Pilot.FallBonus = 0;
  Pilot.StandBonus = 0;
  Pilot.LatShift = Off;
  }

CentreMap(Vector.x,Vector.y);

MoveType = RETURNNULL;
while (MoveType == RETURNNULL) {

  if (Options.HighLight == On)
    drawHighLight(Vector.x,Vector.y);

if (getSpeed( 1))  sprintf(wString,"[W]alk %d ",getSpeed( 1));
else  sprintf(wString,"");

if (getSpeed( 2))  sprintf(rString,"[R]un %d ",getSpeed( 2));
else  sprintf(rString,"");

if (getSpeed( 3) && Pilot.Sprint == On) sprintf(sString,"[X]Sprint %d ",getSpeed( 3));
else sprintf(sString,"");

if (getSpeed( 4) && Pilot.Evade  == On && LeftLeg.Hip == On && RightLeg.Hip == On)  sprintf(eString,"[E]vade %d ", getSpeed( 4));
else  sprintf(eString,"");

//printf("2 %s  ",sString);

if (getSpeed(-1))  sprintf(jString,"[J]ump %d ",getSpeed(-1));
else  sprintf(jString,"");

if (MASCType == 1 && MASCState == Off && getSpeed(1) > 0)  sprintf(mString,"[M]ASC ");
else  sprintf(mString,"");

//printf("3 %s  ",jString);

  sprintf(aString,"[S]tand "); // Mech Stands

if (Position)
  sprintf(iString,"%s %s%s%s%s%s%s%s",Name, wString,rString,sString,eString,jString,aString,mString);
else
  sprintf(iString,"%s %s%s%s%s%s%s [PRONE]%s",Name, wString,rString,sString,eString,jString,aString,mString);

  sprintf(String,"%-55s [A]SD [U]Sur. Heat %d",iString,Heat);

  putString(String,Colour); // String Colour
  MoveType = getMoveType(getkey());
  }
MP = getSpeed(MoveType);
HexesMoved = 0;

i = 0;
char *StandFall[4] = {"[S]tand",
                      "[P]rone",
                      "[L]and",
                      0x0000};

if (GyroHits == 1 && MoveType > 1) // Mechs with damaged gyros may fall if running
  if (roll2d6 < genPilotModifier()) Fall(Altitude);

while (i!=2 && MP > 0) {

  if (MoveType >= 0) // Mech moving on land
    if (Pilot.LatShift == On)
      sprintf(iString,"%s   %s : %d [%d%c] %s [Ins] Shift",Name, MovType [0][TypeCon[MoveType]] ,MP,Vector.head,248,StandFall[Position]);
    else
      sprintf(iString,"%s   %s : %d [%d%c] %s",Name, MovType [0][TypeCon[MoveType]] ,MP,Vector.head,248,StandFall[Position]);
  else
    sprintf(iString,"%s   %s : %d [%d%c]",Name, MovType [0][TypeCon[-MoveType+4]] ,MP,Vector.head,248,Heat);

  sprintf(String,"%-60s Heat %d ",iString,Heat);

  putString(String,Colour);

  if (Options.HighLight == On)
    drawHighLight(Vector.x,Vector.y);

  i=Move(getkey());
  }

if (MoveType < 0) { // Mech is jumping and can land any direction
//if (HexesMoved == 0)
  sprintf(String,"%s choose direction",Name);
  putString(String,Colour);

  while (Move(getkey()) != 2);

  if (Carrying >= 0) // Battlemech Carrying a unit
    if (unit[Carrying]->Side != Side)
      if (PilotingRoll >= genPilotModifier()+4)
        unit[Carrying]->Drop(11); // Elemental / Infantry drop to ground
  }

  if (GyroHits == 1 && MoveType < 0) // Mechs with damaged gyros may fall if landing for a jump
    if (PilotingRoll < genPilotModifier()) Fall(Altitude);

// Mech Ends Turn in Fire
  if (Map.Hex[Vector.x][Vector.y].Fire == 'f' || Map.Hex[Vector.x][Vector.y].Fire == 'F')
    HeatTurn += 5;

//Battlemech carrying Infantry
  if (Carrying >= 0) // Battlemech Carrying a unit
    if (unit[Carrying]->Side != Side && unit[Carrying]->Type == INFANTRY) {
      if (Map.Hex[Vector.x][Vector.y].Fire == 'f' || Map.Hex[Vector.x][Vector.y].Fire == 'F')
        if (PilotingRoll >= genPilotModifier()+4)
          if (PilotingRoll >= 8)
            unit[Carrying]->Drop(50); // Infantry destroyed in fire
          else
            unit[Carrying]->Drop(0);  // Infantry drops to ground
       if (Submersed == On)
         unit[Carrying]->Drop(50); // Infantry destroyed in water
         }

if (Stacked == On)
  for (i=0;i<Units;i++)
    if (Vector.x == unit[i]->Vector.x && Vector.y == unit[i]->Vector.y && unit[i]->Type < INFANTRY && i != Index) {
      // Mechs can only stack with Infantry
      Stacked = Off;
      Vector  = LastVector;
      }
//  drawUnits();

  Used = On;
  if (Options.HighLight == On)
    drawLowLight(Vector.x,Vector.y);

return 0;
}



int Mech::ReactionPhase () {

if (Options.ReactionPhase == Off || Immobile == On || Status == Off) return 0;
if (Pilot.AIReactionPhase == On) return AIReactionPhase() ; // AI Control

char String[80],iString[80];
char Trees = 0;
char ch = 0;
int  i,Itemnear = -1;

  CentreMap(Vector.x,Vector.y);

  if (Map.Hex[Vector.x][Vector.y].Type == 't' || Map.Hex[Vector.x][Vector.y].Type == 'T' && Holding == -1)
    Trees = 1;

  if (Map.Hex[Vector.x][Vector.y].Type == 'R' && Holding == -1)
    Trees = 1;

  for (i=0;i<Items;i++)
    if (Vector.x == Item[i].Vector.x && Vector.y == Item[i].Vector.y && Holding == -1)
      Itemnear = i;

  // If Mech has no hands, it can't pick anything up
  if (RightArm.Hand == Off && LeftArm.Hand == Off) Trees = 0,Itemnear = -1;
  if (MechType == QUADMECH) Itemnear = -1;
//  textprintf(screen,font,20,20+Index*8,makecol(255,255,255),"%s %d %d %d %d",Name,RightArm.Length,LeftArm.Length,RightArm.Hand,LeftArm.Hand);

    sprintf(String,"%s [<]/[>] Torso [E] Eject [I] Info ",Name);
// Quads can't torso twist
  if (MechType == QUADMECH) sprintf(String,"%s [E] Eject [I] Info",Name);

  sprintf(iString,"%s [ ] Done ",String);
  if (Trees == 1 && Itemnear == -1 && Holding == -1) // Tree Club Available
    sprintf(iString,"%s [G] Get Club [ ] Done ",String);
  if (Itemnear != -1 && Holding == -1) // Tree Club Available
    sprintf(iString,"%s [G] Get Item [ ] Done ",String);
  if (Holding != -1) // Tree Club Available
    sprintf(iString,"%s [D] Drop Item [ ] Done ",String);

  sprintf(String,"%-65s Heat [%d]",iString,Heat);
  putString(String, Colour);

  while (ch != RETURNNULL) {
    if (Options.HighLight == On)
    drawHighLight(Vector.x,Vector.y);

    switch (getkey()) {
    case Left : if (MechType != QUADMECH) Turret =-60; ch = RETURNNULL; break;
    case Right: if (MechType != QUADMECH) Turret = 60; ch = RETURNNULL; break;

    case 'g': ;
    case 'G': if (Trees == 1 && Itemnear == -1 && Holding == -1) Holding = -2;
              if (Itemnear != -1 && Holding == -1) Holding = Itemnear;
              sprintf(iString,"%s [<]/[>] Torso [E] Eject [I] Info [ ] Done",Name);
              sprintf(String,"%-65s Heat [%d]",iString,Heat);
              putString(String, Colour);
              break; // Get Club / Item
    case 'd': ;
    case 'D': if (Holding != -1) Holding = -1; break;
    case 128+120  : ;
    case PgUp : ScrollUp();break;
    case 128+121  : ;
    case PgDn : ScrollDn();break;
    case 128+122  : ;
    case Home : ScrollLt();break;
    case 128+123  : ;
    case End  : ScrollRt();break;
    case 128+125: ;
    case 'i': getInfo()       ; break;
    case 'E': Status = 0; Immobile = On;
    case 'e': Status = 0; Immobile = On;
    case ESC: ExitGame(0)     ; break;
    case 32 : ch = RETURNNULL ; break;
    case 13 : ch = RETURNNULL ; break;
    case 'C': ;
    case 'c': CentreMap(Vector.x,Vector.y) ;break;    
    case CTRLA: ToggleFastAI         (); break;
    case CTRLG: ToggleGrid           (); break;
    case CTRLW: ToggleShowWeapons    (); break;
    case CTRLS: ToggleCentreMap      (); break;
    case CTRLH: ToggleAltitudeDisplay(); break;
    case CTRLD: ToggleMovementDice   (); break;
    case CTRLO: ShowOptions          (); break;
    case CTRLE: screen_shot          (); break;
    default : break;
    };
  }

  if (MechType == QUADMECH)
    Turret = 0;
  
  Used = On;
  if (Options.HighLight == On)
    drawLowLight(Vector.x,Vector.y);


return 0;
}

/////////////////////////////////////////////////////////////////////////////
// Weapon Phase
//
//
//

int Mech::WeaponPhase()
{

if (Options.WeaponPhase == Off || Immobile == On || Status == Off) return 0;
if (Pilot.AIWeaponPhase == On) return AIWeaponPhase() ; // AI Control

byte ch=0;
int i;
char iString[80], String[80];
int Angle;
//class Unit *Target;
int Target;
struct Vector TargetVector;
//Target = SelectTarget(*u); // Only returns mech on other Side
// Fire (Twist Eject) Info Done
// If Weapon Fired, Set Flag to 127

Pilot.TargetPenalty = 0;
Pilot.Aim           = 0;
Pilot.AimTarget     = 0;

TurnDamage          = 0;        // 20 points make it fall
StartPosition       = Position; // Units starts Standing / Prone
  CentreMap(Vector.x,Vector.y);
  if (Options.HighLight == On)
    drawHighLight(Vector.x,Vector.y);

  // Initialize Weapons
  for (ch=0;ch<Weapons;ch++) {
    Flag[ch] = 0;
    WeaponTarget[ch] = -1;
    }

while (ch != ENTER && ch != SPACE && ch != RETURNNULL) {
//  drawScreen();
  if (Options.AimedShots == On && Pilot.TargetPenalty == 0)
    sprintf(iString,"%s  [F]ire [A]imed Shot [W]eapon Config [I]nfo [ ] Done ",Name);
  else
    sprintf(iString,"%s  [F]ire [W]eapon Config [I]nfo [ ] Done ",Name);

  sprintf(String,"%-65s Heat [%d]",iString,Heat);
  putString(String,Colour);
  if (Options.HighLight == On)
    drawHighLight(Vector.x,Vector.y);

  ch = getkey();
  switch (ch) {
    case 'A'  : ;
    case 'a'  : if (Pilot.TargetPenalty == 0) ch = AimedShot() ;break;
    case 'w'  : ;
    case 'W'  : ConfigWeapons();break;
    case 'f'  : ;
    case 'F'  :
//    sprintf(String,"Select Target",Name);
//    putString(String,Colour);
    if (MoveType == 3 || MoveType == 4) break;

    Cursor.x = Vector.x;
    Cursor.y = Vector.y;

    Target = getTarget(1); // Target Enemies Only

    if (Carrying >= 0 && Target == Carrying) break;

    // If Target == -1, then it has targeted a hex
    if (Target != -1) {
      sprintf(String,"Target : [%s]",unit[Target]->Name);
      putString(String,Colour);
  
      Angle = getAttackAngle(Vector,unit[Target]->Vector);
      genToHit(*unit[Target]); // Sets Flag as the To Hit
      WeaponSelect(getAttackAngle(Vector,unit[Target]->Vector)-Turret,Target);
      SetWeaponTarget(unit[Target]);

      if (Options.SimultaneousWeaponFire == Off) {
      if (Options.ShowWeaponFire == On)
        for (i=0;i<Weapons;i++)
          if (WeaponTarget[i] != -1) {
//            Target = WeaponTarget[i];
//            ShowWeaponFire(i,unit[Target]);
            ShowWeaponFire(i,unit[WeaponTarget[i]]);
            }

        unit[Target]->Hidden=On;
        unit[Target]->ResolveWeapons(unit[Index]);
        unit[Target]->Hidden=Off;

//        drawHex (unit[Target]->Vector.x,unit[Target]->Vector.y);
//        unit[Target]->drawUnit();
        drawUnits();
        }

      }
    if (Target == -1) {

      TargetVector = Cursor;

      sprintf(String,"Target : [%d][%d]",(TargetVector.x+(TargetVector.y&0x0001))/2,TargetVector.y);
      putString(String,Colour);

      Angle = getAttackAngle(Vector,TargetVector);
      genToHitHex(TargetVector); // Sets Flag as the To Hit
      WeaponSelect(getAttackAngle(Vector,TargetVector)-Turret,-1);

      FakeUnit.Vector = TargetVector;
      FakeUnit.Index  = -1;
      for (i=0;i<Weapons;i++)
        if (Flag[i] >= 2 && Flag[i] <= 12)
          WeaponTarget[i] = -1;
//  else

//      if (Options.ShowWeaponFire == On)
//        ShowWeaponFire(&FakeUnit);
      if (Options.ShowWeaponFire == On)
        for (i=0;i<Weapons;i++)
          if (WeaponTarget[i] == -1)
            ShowWeaponFire(i,&FakeUnit);

      ResolveWeaponsHex(TargetVector);
      drawHex(TargetVector.x,TargetVector.y);
      }

//    if (Options.MultiTarget == On)
    putString(String,Colour);

    ; break;

    case 128+120  : ;
    case PgUp : ScrollUp();break;
    case 128+121  : ;
    case PgDn : ScrollDn();break;
    case 128+122  : ;
    case Home : ScrollLt();break;
    case 128+123  : ;
    case End  : ScrollRt();break;
    case 128+125  : ;
    case 'i'  : ;
    case 'I'  : getInfo()  ;break;
    case 'C'  : ;
    case 'c'  : CentreMap(Vector.x,Vector.y) ;break;
    case QUIT : ExitGame(0);break;
    case CTRLA: ToggleFastAI         (); break;
    case CTRLG: ToggleGrid           (); break;
    case CTRLW: ToggleShowWeapons    (); break;
    case CTRLS: ToggleCentreMap      (); break;
    case CTRLH: ToggleAltitudeDisplay(); break;
    case CTRLD: ToggleMovementDice   (); break;
    case CTRLO: ShowOptions          (); break;
    case CTRLE: screen_shot          (); break;
    default   : ;break;
    }
  }

  Used = On;
  if (Options.HighLight == On)
    drawLowLight(Vector.x,Vector.y);

return 0;
}

int Mech::PhysicalPhase() {

if (Options.PhysicalPhase == Off || Immobile == On || Status == Off) return 0;
if (Pilot.AIPhysicalPhase == On) return AIPhysicalPhase() ; // AI Control

char String[90],iString[70],pString[15],kString[10],uString[10],cString[10],sString[10];

int RightPunchFlag=0, LeftPunchFlag = 0, KickFlag=0, PushFlag=0, ChargeFlag=0,LeftHatchetFlag=0,RightHatchetFlag=0; // Default OFF
int TargetsInRange = 0;
//class Unit *Target;
int Target;
int Angle;
int AltDiff;
int Reach = (RightArm.Length==5||LeftArm.Length==5)?1:0; // 2 if Hatchet or Club
int Range,Modifier,ToHit;

int i;
char ch=0;

PhysAttacks = 0;

for (i=0;i<Units;i++) {
  Angle = getAttackAngle(Vector,unit[i]->Vector);
  Range = doLos(Vector.x,Vector.y,unit[i]->Vector.x,unit[i]->Vector.y);
  AltDiff = (Altitude+(Position)) - (unit[i]->Altitude+(unit[i]->Position));
  if (unit[i]->Side!=Side && unit[i]->Status==On && Range == 1 && Angle <=60 && Angle >=-60 && (AltDiff>=-1 && AltDiff<=Reach+1)) {
//  textprintf(screen,font,20,20+Index*8,makecol24(255,255,255),"Name:%s",Name);
    TargetsInRange ++;
      if (AltDiff == 0 || AltDiff == unit[i]->Position || Altitude == unit[i]->Altitude) // 1 for BattleMechs, 0 for Vehicles
        KickFlag = 1;
      if (AltDiff == 0 || AltDiff ==-unit[i]->Position || AltDiff == -(unit[i]->Position+Reach)) { // 1 for BattleMechs, 0 for Vehicles
        RightPunchFlag = 1; LeftPunchFlag = 1;
      if (abs(Angle) <= 5) PushFlag = 1, ChargeFlag = 1; // If Target Straight Ahead
        }
    }

  }

// Mech Carrying Enemy Infantry
if (Carrying >= 0)
  if (unit[Carrying]->Side != Side) RightPunchFlag = 1, LeftPunchFlag = 1, TargetsInRange ++;

if (TargetsInRange < 1) {
  if (Options.HighLight == On)
    drawLowLight(Vector.x,Vector.y);
      return 1;
      }

  Cursor.x = Vector.x;   Cursor.y = Vector.y;
  if (LeftLeg.Hip       == Off || RightLeg.Hip       == Off) KickFlag = 0;

//sprintf(String,"Player %d's Turn",Side);
//putString(String,Colour); // String Colour
//getkey();
if (Position != STANDING) {
  ChargeFlag = 0;
  PushFlag = 0;
  KickFlag = 0;
  RightPunchFlag = 0;
  LeftPunchFlag = 0;
  RightHatchetFlag = 0;
  LeftHatchetFlag = 0;
  if (Struct[RA] > 0 && Struct[LA] > 0) RightPunchFlag = 1;
  }
if (Reversed != 0) ChargeFlag = 0;

//if (Options.PhysAttacks == On) TargetsInRange = 1; // Allowed to attack buildings

// Unit cannot punch if arm mounted weapons have fired
// Unit cannot kick  if leg mounted weapons have fired
// Unit cannot push  if any arm weapons have fired
// Unit cannot charge if any weapons have fired

  CentreMap(Vector.x,Vector.y);
  if (Options.HighLight == On)
    drawHighLight(Vector.x,Vector.y);

for (i=0;i<Weapons;i++)
  if (Flag[i] > 1 && Flag[i] <= 12 || Flag[i] == 127) {
    if (Weapon[i].Loc == RA || Struct[RA] == 0 ) RightPunchFlag = 0, PushFlag = 0;
    if (Weapon[i].Loc == LA || Struct[LA] == 0 ) LeftPunchFlag  = 0, PushFlag = 0;
    if (Weapon[i].Loc == RL || Struct[RL] == 0 ) KickFlag = 0;
    if (Weapon[i].Loc == LL || Struct[LL] == 0 ) KickFlag = 0;
    ChargeFlag = 0;
    }

  if (RightPunchFlag == 1 && RightArm.Length == 5)
    RightHatchetFlag = 1, RightPunchFlag = 0;
  if (LeftPunchFlag  == 1 && LeftArm.Length  == 5)
    LeftHatchetFlag  = 1, LeftPunchFlag  = 0;

  if (MechType == QUADMECH)
    LeftPunchFlag = 0 , RightPunchFlag = 0;

  if (RightPunchFlag == 0 && LeftPunchFlag == 0 && KickFlag == 0)
    ch = 127;

  if (RightPunchFlag == 1 || LeftPunchFlag == 1) {
    sprintf(pString,"[P]unch");

    if (RightPunchFlag == 1 && LeftPunchFlag == 1)
      sprintf(pString,"Double [P]unch");

    if (RightPunchFlag == 1 && LeftPunchFlag == 1 && Holding != -1)
      sprintf(pString,"[P] Club");

    }
  else
    sprintf(pString,"");

  if (RightHatchetFlag == 1 || LeftHatchetFlag == 1) {
    sprintf(pString," [H]atchet");
    if (RightHatchetFlag == 1 && LeftHatchetFlag == 1 && Holding != -1)
      sprintf(pString," Double [H]atchet");
    }


  if (KickFlag   == 1)
    sprintf(kString," [K]ick");
  else
    sprintf(kString,"");

  if (PushFlag   == 1)
    sprintf(uString," p[U]sh");
  else
    sprintf(uString,"");

  if (ChargeFlag == 1)
    sprintf(cString," [C]harge");
  else
    sprintf(cString,"");

  if (ChargeFlag == 1 && MoveType == -1)
    sprintf(cString," [D]FA");

  if (Carrying >= 0) {
    if (unit[Carrying]->Side != Side)
      if (RightPunchFlag == 1 || LeftPunchFlag == 1) {
        sprintf(sString,"[S]wat");

      if (RightPunchFlag == 1 && LeftPunchFlag == 1)
        sprintf(sString,"Double [S]wat");

      }
  } else
    sprintf(sString,"");

  sprintf(iString,"%s %s%s%s%s%s [ ] Done ",Name,pString,kString,uString,cString,sString);
  sprintf(String,"%-70s Heat [%d]",iString,Heat);

// Select Target
//  Target = SelectTarget(*u);

while (ch != 127) {
  if (Options.HighLight == On)
    drawHighLight(Vector.x,Vector.y);
  putString(String,Colour);
  switch (getkey()) {
  case 'H': ;
  case 'h':
            if (RightHatchetFlag == 1 && LeftHatchetFlag == 1 && Holding != -1) {
              Target=getTarget(1);
              if(Target!=-1&&Target!=Index&&1==doLos(Vector.x,Vector.y,unit[Target]->Vector.x,unit[Target]->Vector.y)) {
                Club(unit[Target],RightHatchetType,RA); Club(unit[Target],LeftHatchetType,LA); ch=127; } }
              else {
            if (RightHatchetFlag == 1 || LeftHatchetFlag == 1) {
              Target=getTarget(1);
              if(Target!=-1&&Target!=Index&&1==doLos(Vector.x,Vector.y,unit[Target]->Vector.x,unit[Target]->Vector.y)) {
              if (RightHatchetFlag == 1 ) Club(unit[Target],RightHatchetType,RA);else Club(unit[Target],LeftHatchetType,LA); ch=127; } }
            // Punch after hatchet Attack
            if (RightPunchFlag == 1 || LeftPunchFlag == 1)  // Punch
              if(Target!=-1&&Target!=Index&&1==doLos(Vector.x,Vector.y,unit[Target]->Vector.x,unit[Target]->Vector.y)) {
              if (RightPunchFlag == 1 )Punch(unit[Target],RA);else Punch(unit[Target],LA); ch=127; }
               } ;break;
  case 'P': ;
  case 'p': if (RightPunchFlag == 1 && LeftPunchFlag == 1)
              if (Holding != -1) { // Club with Item
              Target=getTarget(1);
              if(Target!=-1&&Target!=Index&&1==doLos(Vector.x,Vector.y,unit[Target]->Vector.x,unit[Target]->Vector.y)) {
              Club(unit[Target],0,0);if(Holding==-2)Holding=-1; ch=127;} }
              else { // Double Punch
              Target=getTarget(1);
              if(Target!=-1&&Target!=Index&&1==doLos(Vector.x,Vector.y,unit[Target]->Vector.x,unit[Target]->Vector.y)) {
              Punch(unit[Target],RA);Punch(unit[Target],LA); ch=127;} }
              else

            if (RightPunchFlag == 1 || LeftPunchFlag == 1) { // Punch
              Target=getTarget(1);
              if(Target!=-1&&Target!=Index&&1==doLos(Vector.x,Vector.y,unit[Target]->Vector.x,unit[Target]->Vector.y)) {
              if (RightPunchFlag == 1 )Punch(unit[Target],RA);else Punch(unit[Target],LA); ch=127; }
              } ;break;
  case 'K': ;
  case 'k': if(KickFlag==1) {  // Kick
              Target=getTarget(1);
              if(Target!=-1&&Target!=Index&&1==doLos(Vector.x,Vector.y,unit[Target]->Vector.x,unit[Target]->Vector.y)) {
              Kick  (unit[Target]); ch=127;}} ;break;
  case 'U': ;
  case 'u': if(PushFlag==1) { // Push
              Target=getTarget(1);
              Angle = getAttackAngle(Vector,unit[Target]->Vector);
              if(Target!=-1&&Target!=Index&&1==doLos(Vector.x,Vector.y,unit[Target]->Vector.x,unit[Target]->Vector.y)&&abs(Angle)<=5) {
              Push  (unit[Target]); ch=127;}} ;break;
  case 'C': ;
  case 'c': if(ChargeFlag==1) { // Charge
              Target=getTarget(1);
              Angle = getAttackAngle(Vector,unit[Target]->Vector);
              if(Target!=-1&&Target!=Index&&1==doLos(Vector.x,Vector.y,unit[Target]->Vector.x,unit[Target]->Vector.y)&&abs(Angle)<=5) {
              Charge(unit[Target]); ch=127;}} ;break;
  case 'D': ;
  case 'd': if(ChargeFlag==1&&MoveType==-1) { // Death From Above
              Target=getTarget(1);
              Angle = getAttackAngle(Vector,unit[Target]->Vector);
              if(Target!=-1&&Target!=Index&&1==doLos(Vector.x,Vector.y,unit[Target]->Vector.x,unit[Target]->Vector.y)&&abs(Angle)<=5) {
              DFA   (unit[Target]); ch=127;}} ;break;
  case 'S': ;
  case 's': if (Carrying >= 0)
              if (unit[Carrying]->Side != Side)
            if (RightPunchFlag == 1 && LeftPunchFlag == 1) {
              Swat(unit[Carrying],RA);Swat(unit[Carrying],LA); ch=127;}
              else
            if (RightPunchFlag == 1 || LeftPunchFlag == 1) { // Punch
              if (RightPunchFlag == 1 )Swat(unit[Carrying],RA);else Swat(unit[Carrying],LA); ch=127; }
            ;break;

  case 128+120  : ;
  case PgUp : ScrollUp();break;
  case 128+121  : ;
  case PgDn : ScrollDn();break;
  case 128+122  : ;
  case Home : ScrollLt();break;
  case 128+123  : ;
  case End  : ScrollRt();break;
  case 128+125: ;
  case 'I': ;
  case 'i': getInfo(); break;
  case ESC:ExitGame(0); break;
  case 32 : ch = 127 ; break;
  case 13 : ch = 127 ; break;
//  case 'C': ;
//  case 'c': CentreMap(Vector.x,Vector.y) ;break;
  case CTRLA: ToggleFastAI         (); break;
  case CTRLG: ToggleGrid           (); break;
  case CTRLW: ToggleShowWeapons    (); break;
  case CTRLS: ToggleCentreMap      (); break;
  case CTRLH: ToggleAltitudeDisplay(); break;
  case CTRLD: ToggleMovementDice   (); break;
  case CTRLO: ShowOptions          (); break;
  case CTRLE: screen_shot          (); break;
  default : ;break;
  }
  }

  Used = On;
  if (Options.HighLight == On)
    drawLowLight(Vector.x,Vector.y);

return 0;
}

int Mech::HeatPhase()
{
int i,j,k=Heat;

if (Options.HeatPhase == Off) return 0;

//clrscr();
//textattr(Colour);
//MoveType
//if (Options.HeatPhase == On) {

  switch (MoveType) {
    case 0: k+= 0; break;
    case 1: k+= 1; break;
    case 2: k+= 2; break;
    case 3: k+= 3; break;
    case-1: j = HexesMoved;j<3?j=3:j; k+= j; break;
    default :;break;
    }

  for (i=0;i<Weapons;i++)
    if (Flag[i] > 0)
      k += WeaponTable[Weapon[i].Type].Heat*Weapon[i].RateOfFire;

  Heat = k;

  if (EngineHits == 1 && ShutDown == 0) Heat += 5;                     // Engine Damage
  if (EngineHits == 2 && ShutDown == 0) Heat += 10;
  if (EngineHits >= 3                 ) Status = Off, Immobile = On;

  if (LifeSupportHits == 1 && Heat >= 25) Pilot.Hits++ , ConcRoll(); // LifeSupport Damage
  if (LifeSupportHits == 2 && Heat >= 25) Pilot.Hits+=2, ConcRoll();
    else if (LifeSupportHits == 2 && Heat >= 15) Pilot.Hits++, ConcRoll();

  if (Infernos > 0) Heat+=6, Infernos --;

  Heat += HeatTurn;
  if (HeatSinkType == 0)
    Heat -= HeatSinks;
  else
    Heat -= HeatSinks*2;

  if (Map.Hex[Vector.x][Vector.y].Type == 'w' || onRiver(Vector.x,Vector.y))
    Heat -= 4; // -4 if in Water

  Heat <= 0 ? Heat = 0:k;

  // Ammunition Explosions
  if (roll2d6 < HeatAmmo[Heat]) {
    j = 5000;    k = 0;
    for (i=0;i<Ammunitions;i++) {
      if (Ammo[i].ExplodeDamage*Ammo[i].Ammo < j && Ammo[i].Ammo > 0 && Ammo[i].ExplodeDamage > 0) {
        j=Ammo[i].ExplodeDamage*Ammo[i].Ammo; k = i; }
      }
    if (k<Ammunitions)
      AmmoExplosion(Ammo[k].Loc,Ammo[k].Pos);
    }

  if (Options.PilotShutDownBonus == On)
    if (roll2d6 >=((HeatShut[Heat]-6)+Pilot.Piloting)) ShutDown = 0;
      else ShutDown = 1;
    else
  if (roll2d6 >=  HeatShut[Heat] ) ShutDown = 0;
    else ShutDown = 1;

  if (Heat > 30) ShutDown = 1;
  if (ShutDown == 1) Immobile = 1;

return 0;
}

int Mech::EndPhase()
{
int MechWar[8] = {0,3,5,7,10,11,13,0x0000};
int i;

if (Options.EndPhase == Off) return 0;
//Pilot Regains Conciousness
  if (Pilot.Stun == 0 && Pilot.Conscious == Off)
    if (roll2d6 >= MechWar[Pilot.Hits]) Pilot.Conscious = On,Pilot.Stun = 0;
    
  Turret = 0;

  for (i=0;i<Weapons;i++)
    Flag[i] = 0; // Set Weapons back to Off

  for (i=0;i<2;i++)
    PhysAttack[i].Fall = 0;
    
  Pilot.Stun = 0; // Pilot Can Regain Consciouness next turn;
  HeatTurn   = 0;
  if (ShutDown == 0 && Pilot.Conscious == On) Immobile = Off;

  if (Heat >= 9 && MyomerType == 1) TSMState = On;
    else TSMState = Off;

  MASCState = Off;
  if (MASCNumber < 12) MASCNumber -= 2;  // If MASC not damaged
  if (MASCNumber < 3 ) MASCNumber = 3;   // Sets Masc

  if (Status == Off) Immobile = On;
  
  if (Status == Off) Type = RUBBLE;

return 0;
}

