
static unsigned int lpt_base;           /* Set to base I/O address */

/* Return input value as five-bit number. If input has changed since
   this function was last called, verify that the input is stable. */

unsigned int input_value(void) {
   static unsigned char last_value = 0xFF;
   auto unsigned char new1, new2;
   new1 = inportb(lpt_base + 1) & 0xF8;
   if (new1 != last_value) {
      while (1) {
	 new2 = inportb(lpt_base + 1) & 0xF8;
	 if (new2 == new1)      /* Wait for stable value */
	    break;
	 new1 = new2;
	 }
      last_value = new1;
      }
   return (last_value ^ 0x80) >> 3;
   }

/* Receive an 8-bit byte value, returns -1 if no data available yet */

signed int receive_byte(void) {
   unsigned int portvalue, bytevalue;
   portvalue = input_value();           /* Read input */
   if ((portvalue & 0x10) == 0)
      return 256;                       /* Await high flag */
   outportb(lpt_base, 0x10);            /* Assert reverse flag */
   bytevalue = portvalue & 0x0F;        /* Keep low nibble */
   do {
      portvalue = input_value();
   } while ((portvalue & 0x10) != 0);   /* Await low flag */
   outportb(lpt_base, 0);               /* Deassert reverse flag */
   bytevalue |= (portvalue << 4);       /* High nibble */
   return bytevalue & 0xFF;
   }

/* Transmit an 8-bit byte value, won't return until value is sent */

void transmit_byte(unsigned int val) {
   val &= 0xFF;
   outportb(lpt_base, (val & 0x0F) | 0x10);     /* Set nibble flag */
   while ((input_value() & 0x10) == 0)
      ;                                 /* Await returned flag high */
   outportb(lpt_base, val >> 4);        /* Clear nibble flag */
   while ((input_value() & 0x10) != 0)
      ;                                 /* Await returned flag low */
   return;
   }

void transmit_int(int val) {
  transmit_byte(val & 0xFF);
  transmit_byte(val  >>  8);
  return;
  }

int receive_int(void) {
  return receive_byte()+receive_byte()<<8;
  }

int receive_Buffer(char *Buffer, int Size){
byte ch;
int i=0;

while (ch != 27 && i <= Size) {
  ch = receive_byte();
  if (ch == 256) {
    if (kbhit()) {
      ch = getch();
      if (ch == 27) return 3;
      transmit_byte(ch);
//      printf("%c",ch);
      if (ch == 13);
//        printf("\n");
    }
    }
  else {
    Buffer[i] = ch;
    printf("%c",ch);
    if (ch == 13);
//      printf("\n");
  }
  i++;
  }

}

int receive_BufferText(char *Buffer, int Size){
byte ch;
int i=0;

//Buffer = (char *)malloc(Size);

while (ch != 27 && i <= Size) {
  ch = receive_byte();
  if (ch == 256) {
    if (kbhit()) {
      ch = getch();
      if (ch == 27) return 3;
      transmit_byte(ch);
      printf("%c",ch);
      if (ch == 13)
        printf("\n");
    }
    }
  else {
    Buffer[i] = ch;
    printf("%c",ch);
    if (ch == 13)
      printf("\n");
  }
  i++;
  }

}

int proc_MapData(char *Buffer) {
int i,j,k;
k = 0;

for (j=0;j<16;j++)
  for (i=0;i<34;i++) {
    Map.Hex[i][j].Type = Buffer[k  ];
    Map.Hex[i][j].Alt  = Buffer[k+1];
    k += 2;
  }

return 0;
}
