int transmit_HexData (int x, int y, HexData Hex) {

  transmit_byte( 92  ); // BackSlash Character
  transmit_byte( 'h' ); // Send Map

  transmit_int ( x );    // Hex X position
  transmit_int ( y );    // Hex Y position
  transmit_byte( Hex.Type ); // Forest / Clear
  transmit_byte( Hex.Cond ); // Snow / Sand
  transmit_byte( Hex.Road ); // ( ) None 0 - lvl 0 road 3 - lvl 3 road C (3+An) lvl 3 road with a river at altitude
  transmit_byte( Hex.Alt  ); // Altitude  -10 / 10 levels
  transmit_byte( Hex.Fire ); // Fire / Smoke flag
  transmit_byte( Hex.Index); // + If a building / Geyser, else -1

return 0;
}

int transmit_MapData (MapData Map) {
int i,j;

//  transmit_byte( 92  ); // BackSlash Character
//  transmit_byte( 'm' ); // Send Map

//  transmit_int ( Map.x1 );
//  transmit_int ( Map.y1 );
//  transmit_int ( Map.x2 );
//  transmit_int ( Map.y2 );

//  textprintf(screen,font,20,20,EGAColour[4]," <>%d <>%d <>%d <>%d",Map.x1,Map.x2,Map.y1,Map.y2);

  for (j=Map.y1;j<Map.y2;j++) {
    for (i=Map.x1;i<Map.x2;i++)
      transmit_HexData (i,j,Map.Hex[i][j]);
//      transmit_byte(13);
    }
  return 0;
}

int transmit_GameOptions(GameOptions Options) {
  transmit_byte( 92  ); // BackSlash Character
  transmit_byte( 'O' ); // Send Map

// Display Phases
  transmit_byte( Options.InitiativePhase );
  transmit_byte( Options.MovePhase );
  transmit_byte( Options.ReactionPhase );
  transmit_byte( Options.WeaponPhase );
  transmit_byte( Options.PhysicalPhase );
  transmit_byte( Options.HeatPhase );
  transmit_byte( Options.EndPhase );

  transmit_byte( Options.CompressReactionPhase );
  transmit_byte( Options.SimultaneousWeaponFire );
  transmit_byte( Options.SimultaneousPhysicalAttacks );
  transmit_byte( Options.InitiativeBySide ); // Side 1 moves the Side 2
  transmit_byte( Options.MoveUnitsBySide ); // Move every mech on side 1
  transmit_byte( Options.AutoPick );

  transmit_byte( Options.Stacking );

  transmit_byte( Options.ShowSpritePCX );
  transmit_byte( Options.CreateFire );

  transmit_byte( Options.ShowShore );
  transmit_byte( Options.ShowHills );

  transmit_byte( Options.DrawGrid );   // Draws Hexaganol grid on map
  transmit_byte( Options.HighLight );
  transmit_byte( Options.RedrawLowLights );
  transmit_byte( Options.ShowWeaponFire ); // Shows little animations
  transmit_byte( Options.CentreMap );

  transmit_byte( Options.GlancingHits );   // Half damage on exact roll
  transmit_byte( Options.FloatingCrits );  //
  transmit_byte( Options.CriticalHits );   // Critical Hits / On / Off
  transmit_byte( Options.TransferDamage );
  transmit_byte( Options.TwentyPointFalls );
  transmit_byte( Options.SkilledEvade );
  transmit_byte( Options.AimedShots );
  transmit_byte( Options.CalledShots );
  transmit_byte( Options.WeaponJams );
  transmit_byte( Options.HeadShots );
  transmit_byte( Options.GlancingHeadHits );
  transmit_byte( Options.MissileBonus );   // Adds to missile cluster
  transmit_byte( Options.AllSprint );
  transmit_byte( Options.AllEvade );

  transmit_byte( Options.LOSBlock );
  transmit_byte( Options.ElectronicLOS );
  transmit_byte( Options.LinearGunnery );
  transmit_byte( Options.LinearPiloting );

  transmit_byte( Options.AltitudeDisplay );
  transmit_byte( Options.AmmoExplosions );
  transmit_byte( Options.AmmoConsumption );
  transmit_byte( Options.ExtremeRange );
  transmit_byte( Options.MoveFire );   // Compress MoveMent/Fire into one Turn
  transmit_byte( Options.ModeratedAmmoExplosions );
  transmit_byte( Options.AutoMove );   // Automatically Move
  transmit_byte( Options.AutoWeapons );// Automatically Target and fire
  transmit_byte( Options.PilotShutDownBonus );
  transmit_byte( Options.MASCLocks );
  transmit_byte( Options.AngleOfAttack );
  transmit_byte( Options.HexFacings ); // Side of Battlemech is determined from hexside entered

  transmit_byte( Options.ShowTargetTerrain );// shows Terrain before target
  transmit_byte( Options.AutoTarget ); // Automatically Target the Closest Enemy
  transmit_byte( Options.MultiTarget );// Allow Multile engagements in a Turn

  transmit_byte( Options.ChargeMoves );
  transmit_byte( Options.Retreat );    // Unit can leave map
  transmit_byte( Options.AlternateSides );
  transmit_byte( Options.SaveBattleReport );
  transmit_byte( Options.FastAI );
  transmit_byte( char(Options.Gravity*32) );
  transmit_byte( Options.FractionalCover );
  transmit_byte( Options.CumulativeTwentyPointFalls );
  transmit_byte( Options.RunInWater );
  transmit_byte( Options.AltChangeLimit );
  transmit_byte( Options.Level3VehicleCrits );
  transmit_byte( Options.MouseMove );
  transmit_byte( Options.MovementDice );

return 0;
}

int receive_Maps() {
char Buffer[8192];

Map.x1 = 0;
Map.y1 = 0;
Map.x2 = 34;
Map.y2 = 16;

receive_Buffer(Buffer,68*16);
proc_MapData(Buffer);

return 0;
}

int receive_GameOptions(GameOptions Options) {
//  92  // BackSlash Character
//  'O' // Send Map

// Display Phases
  Options.InitiativePhase = receive_byte();
  Options.MovePhase = receive_byte();
  Options.ReactionPhase = receive_byte();
  Options.WeaponPhase = receive_byte();
  Options.PhysicalPhase = receive_byte();
  Options.HeatPhase = receive_byte();
  Options.EndPhase = receive_byte();

  Options.CompressReactionPhase = receive_byte();
  Options.SimultaneousWeaponFire = receive_byte();
  Options.SimultaneousPhysicalAttacks = receive_byte();
  Options.InitiativeBySide = receive_byte(); // Side 1 moves the Side 2
  Options.MoveUnitsBySide = receive_byte(); // Move every mech on side 1
  Options.AutoPick = receive_byte();

  Options.Stacking = receive_byte();

  Options.ShowSpritePCX = receive_byte();
  Options.CreateFire = receive_byte();

  Options.ShowShore = receive_byte();
  Options.ShowHills = receive_byte();

  Options.DrawGrid = receive_byte();   // Draws Hexaganol grid on map
  Options.HighLight = receive_byte();
  Options.RedrawLowLights = receive_byte();
  Options.ShowWeaponFire = receive_byte(); // Shows little animations
  Options.CentreMap = receive_byte();

  Options.GlancingHits = receive_byte();   // Half damage on exact roll
  Options.FloatingCrits = receive_byte();  //
  Options.CriticalHits = receive_byte();   // Critical Hits / On / Off
  Options.TransferDamage = receive_byte();
  Options.TwentyPointFalls = receive_byte();
  Options.SkilledEvade = receive_byte();
  Options.AimedShots = receive_byte();
  Options.CalledShots = receive_byte();
  Options.WeaponJams = receive_byte();
  Options.HeadShots = receive_byte();
  Options.GlancingHeadHits = receive_byte();
  Options.MissileBonus = receive_byte();   // Adds to missile cluster
  Options.AllSprint = receive_byte();
  Options.AllEvade = receive_byte();

  Options.LOSBlock = receive_byte();
  Options.ElectronicLOS = receive_byte();
  Options.LinearGunnery = receive_byte();
  Options.LinearPiloting = receive_byte();

  Options.AltitudeDisplay = receive_byte();
  Options.AmmoExplosions = receive_byte();
  Options.AmmoConsumption = receive_byte();
  Options.ExtremeRange = receive_byte();
  Options.MoveFire = receive_byte();   // Compress MoveMent/Fire into one Turn
  Options.ModeratedAmmoExplosions = receive_byte();
  Options.AutoMove = receive_byte();   // Automatically Move
  Options.AutoWeapons = receive_byte();// Automatically Target and fire
  Options.PilotShutDownBonus = receive_byte();
  Options.MASCLocks = receive_byte();
  Options.AngleOfAttack = receive_byte();
  Options.HexFacings = receive_byte(); // Side of Battlemech is determined from hexside entered

  Options.ShowTargetTerrain = receive_byte();// shows Terrain before target
  Options.AutoTarget = receive_byte(); // Automatically Target the Closest Enemy
  Options.MultiTarget = receive_byte();// Allow Multile engagements in a Turn

  Options.ChargeMoves = receive_byte();
  Options.Retreat = receive_byte();    // Unit can leave map
  Options.AlternateSides = receive_byte();
  Options.SaveBattleReport = receive_byte();
  Options.FastAI = receive_byte();
  Options.Gravity = receive_byte()/32.00;
  Options.FractionalCover = receive_byte();
  Options.CumulativeTwentyPointFalls = receive_byte();
  Options.RunInWater = receive_byte();
  Options.AltChangeLimit = receive_byte();
  Options.Level3VehicleCrits = receive_byte();
  Options.MouseMove = receive_byte();
  Options.MovementDice = receive_byte();

return 0;
}
