
// Alldata should be read from Weapon[i].Damage
// WeaponTable used FOR REFERENCE ONLY!

typedef unsigned int   dword;
typedef unsigned short word;
typedef unsigned char  byte;
typedef short          int16;
typedef int            int32;

#define   MAXWEAPONS            160
#define   MAXAMMOS              80

/*
union bitfield {
  bool AgeofWar;
  bool TerranHegemony;
  bool StarLeague;
  bool AdvStarLeague;
  bool is3025;
  bool is3037;
  bool is3045;
  bool is3050;         // 8
  bool is3055;
  bool is3060;
  bool is3065;
  bool Clan2900;
  bool Clan3050;
  bool Clan3060;
  bool Clan3065;
  bool Custom;
  };

*/

char *Classes[] = {"None",
		   "Laser",
		   "Pulse Laser"
		   "PPC",
		   "Flamer",
		   "AMS",
		   "AutoCannon",
		   "Gause Rifle",
		   "Shot Gun",
		   "Missle",
		   "Rocket",
		   "Heavy Missile",
		   "Artillery",
		   0x0000 };

// Alldata should be read from Weapon[i].Damage
// WeaponTable used FOR REFERENCE ONLY!

typedef struct WeaponType {
char Name[30];
char Code[10]; // 7 chars long - LgPulse
int16 Type;     // 0 = Flamer
int16 Class;    // Energy / Ballistic
int16 Linked;   // Equipment Linked to weapon
	      // Like Cappacitor / Artemis

int16 Loc;
int16 Pos;

int16 Effect;   // Large Lasers have a blue beam
int16 ToHit;    // State
int16 State;    // + 0 Online, / < -1 Offline

int16 Damage;
int16 DamageCluster; // 5 = LRM 8 = LGLAS 2 = SRM
int16 Accuracy; // PLS = -2, MRM = +1
int16 Cluster ; // Artemis = +2  Streak = +12
int16 FireMode; // UA/C = 2 RAC = 6
int16 Capacity; // PPC+Cap = 5
int16 Locking;   // Won't fire unless a target is locked on
int16 Artemis;  // Version
int16 NARC;     // Works with beacon
int16 TargetHeat;
int16 Persistence; // Inferno = 3, all others = 0;
int16 CritChance;  // AP rounds, AC/20 = -1

int16 JamMod;
int16 CurrentFireMode;
int16 RateOfFire;
int16 AmmoIndex;     // Unit.Ammo[] // Index
int16 AmmoTypeIndex; // AmmoTable[] // Index
int16 Swarm;

int16 Missiles;

int16 Heat;

int16 Minimum;
int16 Short;
int16 Medium;
int16 Long;
int16 Extreme;
// Solaris Range Style
 int16 Close;    //+1 Range
 int16 Middle;   //+3 Range
 int16 VeryLong; //+5 Range

int16 MinimumDamage; // T-Bolt only cause half damage
int16 ShortDamage;   // Heavy Gauss causes 25 pts
int16 MediumDamage;  // Heavy Gauss causes 15 pts
int16 LongDamage;    // Heavy Gauss causes 10 pts
int16 ExtremeDamage; // Heavy Gauss causes 10? pts
// Solaris Range Style
 int16 CloseDamage;    //+1 Range // Heavy Gauss causes 20 pts
 int16 MiddleDamage;   //+3 Range // Heavy Gauss causes 12 pts
 int16 VeryLongDamage; //+5 Range // Heavy Gauss causes 10 pts

int16 AmmoType;          // AC / 5
int16 PrimaryAmmo;       // Ammo SubType = UAC/5
int16 AmmoConsumption;   // 0 = Energy 1 = Normal 2+ Special


int16 Jams;              // Weapon Jams On
int16 SelfDestructs;     // Causes Damage

int16 AMS;               // Can be shot down with AMS
int16 TargetsHex;
int16 SaturationDamage ; // Arrow IV = 20
int16 Mines;             // Mines it drops

//int16  Price1;
//int16  Price2;
int32  Price;
int16  BV;

int16 CritSplit;
int16 Crit;
int16 Tons;

int16 DirectFire;        // Can Link to Target Computer
int16 InDirectFire;      // Indirect LRMs / Artillery

//dword Era;             // Bitfield, 16 Technology Levels
//int16  Era1;
//int16  Era2;
int32 Era;

int16 InfantryDamage;    // xD6 Infantry killed
int16 MissileIntercepts;  // xD6 Missiles destroyed
int16 RandomHeat;
int16 RandomConsumption;

int16 BallisticVisibility; // ECM / BAP Data
int16 ArtilleryVisibility; // Required Visibilities;
int16 MissileVisibility;
int16 LightVisibility;     // - Value creates smoke

int16 BallisticIllumination; // ECM / BAP Data
int16 ArtilleryIllumination; // TAG Illuminates targets for Artillery
int16 MissileIllumination;   // and Indirect LRM attacks
int16 LightIllumination;     // - SpotLight?

};

// Alldata should be read from Equip[i]
// EquipTable used FOR REFERENCE ONLY!

typedef struct EquipType {
char Name[30];
char Code[10]; // 7 chars long - LgPlse
int16 Type;     // 0 = Flamer
int16 Class;    // 7 = Missile
int16 Linked;   // Equipment Linked to weapon
              // Like Cappacitor / Artemis
int16 ReqAmmo;  // Ammo Class Required to work properly

int16 State;    // + 0 Online, / < -1 Offline

int16 Damage;
int16 Accuracy; // PLS = -2, MRM = +1
int16 Cluster ; // Artemis = +2  Streak = +12
int16 FireMode; // UA/C = 2 RAC = 6
int16 Capacity; // PPC+Cap = 5
int16 CritChance;  // AP rounds, AC/20 = -1

int16 Heat;

int16 Range;

int16 Jams;              // Weapon Jams On
int16 SelfDestructs;     // Causes Damage

int16 Indirect;

long Price;
int16  BV;

int16 Crit;
int16 Tons;              // * 4 for fixed Math?

word Era;              // Bitfield, 16 Technology Levels

int16 BallisticIllumination; // ECM / BAP Data
int16 ArtilleryIllumination;
int16 MissileIllumination;
int16 LightIllumination;
};

// Like WeaponTable

typedef struct AmmoTypes {
char Name[30];
char Code[10]; // 7 chars long - LgPulse
int16 Type;     // Index
int16 AmmoType; // Ammo Type - AC/5 == 8
int16 SubType;  // AC/5 Precision

int16 Loc;
int16 Pos;

int16 Ammo;    // + 0 Rounds remaining, / < -1 Offline

int16 Damage;
int16 DamageCluster; // 5 = LRM 8 = LGLAS 2 = SRM
int16 Accuracy; // PLS = -2, MRM = +1
int16 Cluster ; // Artemis = +2  Streak = +12
int16 ExplodeDamage; // SRM 6 = 12 per round
int16 CritChance;    // AP rounds, AC/20 = -1
int16 Locking ;      // Won't fire unless a target is locked on
int16 Artemis ; // Version / If enabled gets bonus
int16 ArtemisAcc; // Accuracy Bonus
int16 ArtemisCls; // Cluster Bonus
int16 NARCAcc; // Accuracy Bonus
int16 NARCCls; // Cluster Bonus
int16 TargetHeat;
int16 Persistence; // Inferno = 3, all others = 0;

int16 Missiles;    // Additional Missiles

int16 Minimum;
int16 Short;
int16 Medium;
int16 Long;
int16 Extreme;
// Solaris Range Style
 int16 Close;    // +1 Range
 int16 Middle;   //+3 Range
 int16 VeryLong; //+5 Range

int16 MinimumDamage; // T-Bolt only cause half damage
int16 ShortDamage;   // Heavy Gauss causes 25 pts
int16 MediumDamage;  // Heavy Gauss causes 15 pts
int16 LongDamage;    // Heavy Gauss causes 10 pts
int16 ExtremeDamage; // Heavy Gauss causes 10? pts
// Solaris Range Style
 int16 CloseDamage;    //+1 Range // Heavy Gauss causes 20 pts
 int16 MiddleDamage;   //+3 Range // Heavy Gauss causes 12 pts
 int16 VeryLongDamage; //+5 Range // Heavy Gauss causes 10 pts


int16 Jams;              // Weapon Jams On
int16 SelfDestructs;     // Causes Damage

int16 AMS;               // Can be shot down with AMS
int16 TargetsHex;
int16 SaturationDamage ; // Arrow IV = 20
int16 Indirect;
int16 Mines;             // Mines it drops

int32 Price;
//int16  Price1;
//int16  Price2;
int16  BV;

int16 Crit;
int16 Tons;              // Fraction of a Ton (Quater Tons)

int16 DirectFire;        // Can Link to Target Computer
int16 InDirectFire;      // Indirect LRMs / Artillery

int32  Era;             // Bitfield, 24 Technology Levels
//int16  Era1;
//int16  Era2;

int16 InfantryDamage;    // xD6 Infantry killed
int16 MissleIntercepts;  // xD6 Missiles destroyed
int16 RandomHeat;
int16 RandomConsumption;

int16 BallisticVisibility; // ECM / BAP Data
int16 ArtilleryVisibility; // Required Visibilities;
int16 MissileVisibility;
int16 LightVisibility;

int16 BallisticIllumination; // ECM / BAP Data
int16 ArtilleryIllumination; // TAG Illuminates targets for Artillery
int16 MissileIllumination;   // and Indirect LRM attacks
int16 LightIllumination;     // - SpotLight?

};


WeaponType   WeaponTable[MAXWEAPONS];
AmmoTypes    AmmoTable[MAXAMMOS];
int16        Weapons;
int16        Ammos;

int ReadWeaponType(char *String) {
int i,j;
FILE *FileIn;
FileIn  = fopen(String,"rb");

if (FileIn == NULL) { Weapons = 0; return 0; }

Weapons = fgetc(FileIn);

for (i=0;i<Weapons;i++)
  fread(&WeaponTable[i],sizeof(WeaponType),1,FileIn);
//  fread(&Weapon[i],142,1,FileIn);

fclose(FileIn);
return 0;
}


int ReadAmmoType(char *String) {
int i,j;
FILE *FileIn;
FileIn  = fopen(String,"rb+");

if (FileIn == NULL) { Ammos = 0; return 0; }

Ammos = fgetc(FileIn);
for (i=0;i<Ammos;i++)
  fread(&AmmoTable[i],sizeof(AmmoTypes),1,FileIn);

fclose(FileIn);
//for (i=0;i<24;i++)
//  printf("%2d> %-20s %2d %2d %2d\n",i,AmmoTable[i].Name,AmmoTable[i].Ammo,AmmoTable[i].Damage,AmmoTable[i].Missiles);

//getch();
return 0;
}


